#ifndef __GNUC__
#define bool int
#endif
#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include<math.h>
#define mx 256
#define pols 13
#define pts 45
#define in stdin;//fopen("c:\\tp\\tests\\f.inp","r")
FILE*fn;
#define eps 1e-9
#define inf 1e12

struct point
{
double x,y;
point (){x=y=0.0;};
point (double a,double b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

struct lineeq{double a,b,c;};

bool eq(double a,double b){if(a-b<eps&&b-a<eps)return 1;return 0;}
int get(double a)
  {if(eq(a,0.0))return 0;else if(a>0.0)return 1;else return -1;}

point operator^(const point&a,const double&b){return point(cos(b)*a.x-sin(b)*a.y,sin(b)*a.x+cos(b)*a.y);}
point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
point operator*(double&a,const point&b){return point(a*b.x,a*b.y);}
double operator!(const point&a){return hypot(a.x,a.y);}
double operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
double operator~(const point&a){return atan2(a.y,a.x);}
bool operator==(const point&a,const point&b){return eq(a.x,b.x)&&eq(a.y,b.y);}
bool operator<(const point&a,const point&b)
  {return ((~a<~b)&&(!eq(~a,~b)))||(eq(~a,~b)&&!a<!b);}

bool operator==(const line&a,const line&b)
  {return (a.a==b.a&&a.b==b.b)||(a.b==b.a&&a.a==b.b);}

bool operator||(const line&a,const line&b)
  {return eq((a.b-a.a)^(b.a-a.a),(a.b-a.a)^(b.b-a.a));}

double det2(point&a,point&b,point&c)
  {return (b-a)^(c-a);}

bool operator>(const line&a,const line&b)
  {int s1=get((a.b-a.a)^(b.a-a.a));
  int s2=get((a.b-a.a)^(b.b-a.a));
  if(s1*s2<=0)return 1;
  else return 0;}

bool operator*(const line&a,const line&b)
  {if(b.a==a.a||b.b==a.a||a.b==b.a||a.b==b.b)return 0;
  return a>b&&b>a;}

/////////////////////////////////////////////////////////////
int c;
int br[mx];
point pol[pols][pts];
double ara[mx];
point all[mx];
int ac;
line al[mx];
int lc;
double dist[mx][mx];
int q1,q2,q3,c1,c2,c3;
double cc1;
double d[mx];
int v[mx];

double area(int a)
  {int q1;
  double res=0.0;
  for(q1=0;q1<br[a];q1++)res+=(pol[a][q1].x-pol[a][q1+1].x)*(pol[a][q1].y+pol[a][q1+1].y);
  if(res<0.0)res=-res;
  return res/2.0;}


bool ifin(line e1,int a)
  {int c1=-1,c2=-1,q1,q2,c3;
  double a1,a2,a3;
  for(q1=0;q1<br[a];q1++)
    if(e1.a==pol[a][q1])c1=q1;
    else if(e1.b==pol[a][q1])c2=q1;
  if(c1==-1||c2==-1)return 0;
  if(c1>c2)c1^=c2^=c1^=c2;
  if(c1==0&&c2==br[a]-1)return 0;
  if(c2-c1==1)return 0;
  c3=br[a];

  a3=ara[a];
  for(q1=c1;q1<=c2;q1++)pol[c][q1-c1]=pol[a][q1];
  br[c]=c2-c1+1;
  pol[c][br[c]]=pol[c][0];
  a1=area(c);
  for(q1=c2;q1<c3;q1++)pol[c][q1-c2]=pol[a][q1];
  for(q1=0;q1<=c1;q1++)pol[c][q1+(c3-c2)]=pol[a][q1];
  br[c]=br[a]-br[c]+2;
  pol[c][br[c]]=pol[c][0];
  a2=area(c);
  if(eq(a1,0.0)||eq(a2,0.0))return 0;
  if(eq(a1+a2,a3))return 1;
  return 0;}



int clear(void)
  {int q1,q2;
  for(q1=0;q1<mx;q1++)for(q2=0;q2<mx;q2++)dist[q1][q2]=0.0;
  for(q1=0;q1<pols;q1++)for(q2=0;q2<pts;q2++)pol[q1][q2]=point(0.0,0.0);
  c1=c2=c3=0;
  cc1=0.0;
  ac=lc=c=q3=0;
  for(q1=0;q1<mx;q1++)ara[q1]=0.0;
  for(q1=0;q1<mx;q1++)all[q1]=pol[0][0];
  for(q1=0;q1<mx;q1++)line(all[0],all[0]);
  return 0;}
int t;
int main()
  {fn=in;
  fscanf(fn,"%d",&t);
  for(;t;t--){clear();

  fscanf(fn,"%d",&c);
  fscanf(fn,"%lf %lf %lf %lf",&all[0].x,&all[0].y,&all[1].x,&all[1].y);
  ac=2;
  for(q1=0;q1<c;q1++)
    {fscanf(fn,"%d",&br[q1]);
    for(q2=0;q2<br[q1];q2++)fscanf(fn,"%lf %lf",&pol[q1][q2].x,&pol[q1][q2].y);
    pol[q1][br[q1]]=pol[q1][0];
    for(q2=0;q2<br[q1];q2++)
      {al[lc++]=line(pol[q1][q2],pol[q1][q2+1]);
      all[ac++]=pol[q1][q2];}
    ara[q1]=area(q1);}


  for(q1=0;q1<ac;q1++)for(q2=q1+1;q2<ac;q2++)
    {line e1=line(all[q1],all[q2]);
    c1=0;

    for(q3=0;q3<lc;q3++)
      {if(e1==al[q3]){c1=0;break;}
      if(e1*al[q3])c1++;
      c1=c1;}

    if(c1==0)dist[q1][q2]=dist[q2][q1]=!(all[q1]-all[q2]);
    else dist[q1][q2]=dist[q2][q1]=inf;
    }

  for(q1=0;q1<ac;q1++)for(q2=q1+1;q2<ac;q2++)for(q3=0;q3<c;q3++)if(eq(dist[q1][q2],inf)==0)
    if(ifin(line(all[q1],all[q2]),q3))
      dist[q1][q2]=dist[q2][q1]=inf;

  for(q1=0;q1<ac;q1++)d[q1]=inf;
  d[0]=0.0;
  for(q1=0;q1<ac;q1++)v[q1]=0;
  for(q1=0;q1<ac;q1++)
    {cc1=inf;
    for(q2=0;q2<ac;q2++)if(!v[q2])if(cc1>d[q2]){cc1=d[q2];c2=q2;}
    v[c2]=1;
    for(q2=0;q2<ac;q2++)if(d[c2]+dist[c2][q2]<d[q2])
      d[q2]=d[c2]+dist[c2][q2];
    }
  printf("%.3lf\n",d[1]);

  }fclose(fn);
  return 0;}