#include<cstdio>
#include<cmath>
#include<string>
#include<cstdlib>
#define eps 1e-10
#define inf 1e10
#define sz size()
#define cs c_str()
#define pb push_back
#define in stdin;//fopen("c:\\tp\\tests\\e.in","r")
using namespace std;
FILE*fn;

int eq(double a,double b)
  {double c=a-b;
  if(c<0.0)c=-c;
  if(c<eps)return 1;
  return 0;}

struct expr
  {public:
  double a,b,c;
  expr(){a=b=c=0.0;};
  expr(double aa,double bb,double cc){a=aa;b=bb;c=cc;};
  expr(double cc){c=cc;a=b=0.0;}
  };

struct frac
  {public:
  expr a,b;
  frac(){};
  frac(expr aa,expr bb){a=aa;b=bb;};
  frac(double aa){a=aa;b=1.0;}
  frac(expr aa){a=aa;b=1.0;}
  };

expr operator+(const expr&a,const expr&b){return expr(a.a+b.a,a.b+b.b,a.c+b.c);}
expr operator-(const expr&a,const expr&b){return expr(a.a-b.a,a.b-b.b,a.c-b.c);}
expr operator-(const expr&a){return 0.0-a;}
expr operator*(const expr&a,const expr&b){return expr(a.a*b.c+a.b*b.b+a.c*b.a,a.b*b.c+a.c*b.b,a.c*b.c);}
expr operator/(const expr&a,const double&b){return expr(a.a/b,a.b/b,a.c/b);}
bool operator==(const expr&a,const expr&b){return eq(a.a,b.a)&&eq(a.b,b.b)&&eq(a.c,b.c);}
int operator!(const expr&a)
  {if(eq(a.a,0.0)!=1)return 2;
  else if(eq(a.b,0.0)!=1)return 1;
  else if(eq(a.c,0.0)!=1)return 0;
  else return -1;}

frac operator-(const frac&a){return frac(-a.a,a.b);}
frac operator+(const frac&a,const frac&b)
  {return frac(a.a*b.b+b.a*a.b,a.b*b.b);}
frac operator-(const frac&a,const frac&b){return a+(-b);}
frac operator*(const frac&a,const frac&b){return frac(a.a*b.a,a.b*b.b);}
frac operator/(const frac&a,const frac&b){return frac(a.a*b.b,a.b*b.a);}

frac parse(string a)
  {int q1,c1,c2,c3,c4,c5;
  c1=c2=c3=c4=-1;
  string e1,e2;
  char aa;
  if(a[0]=='-')a="0"+a;
  for(q1=c5=0;q1<a.sz;q1++)
    {if(a[q1]=='(')c5++;
    if(a[q1]==')')c5--;
    if(c5!=0)continue;
    if(a[q1]=='+'&&c1==-1)c1=q1;
    if(a[q1]=='-')c2=q1;
    if(a[q1]=='*'&&c3==-1)c3=q1;
    if(a[q1]=='/')c4=q1;}

  c5=-1;
  if(c1!=-1){c5=c1;aa='+';}
  else if(c2!=-1)
    {if(a[c2-1]=='*'||a[c2-1]=='/'||a[c2-1]=='-'||a[c2-1]=='+')
      {a+="+0";
      e1=a.substr(0,c2);
      string e3;
      for(q1=c2+1,c5=0;q1<a.sz;q1++)
        {e3.pb(a[q1]);
        if(a[q1]=='(')c5++;
        if(a[q1]==')')c5--;
        if(c5==0&&(a[q1+1]<'0'||a[q1+1]>'9'))
          {e2=a.substr(q1+1);
          break;}}
      e1=e1+"(-"+e3+")"+e2;
      return parse(e2);}
    c5=c2;
    aa='-';}
  else if(c3!=-1){c5=c3;aa='*';}
  else if(c4!=-1){c5=c4;aa='/';}
  else
    {if(a[0]=='('&&a[a.sz-1]==')')
       return parse(a.substr(1,a.sz-2));
    if(a[0]=='x')return frac(expr(0.0,1.0,0.0));
    sscanf(a.cs,"%d",&c5);
    return frac(c5);}

  e1=a.substr(0,c5);
  e2=a.substr(c5+1);
  frac f1,f2;
  f1=parse(e1);
  f2=parse(e2);

  if(aa=='+')f1=f1+f2;
  if(aa=='-')f1=f1-f2;
  if(aa=='/')f1=f1/f2;
  if(aa=='*')f1=f1*f2;

  return f1;}

int print(expr a){printf("%.3lf*X^2  +  %.3lf*X  +  %.3lf",a.a,a.b,a.c);return 0;}

int print(frac a)
  {printf("(  ");
  print(a.a);
  printf("  ) / (  ");
  print(a.b);
  printf("  )\n");
  return 0;}


double eval(string a,double x)
  {int q1,c1,c2,c3,c4,c5;
  c1=c2=c3=c4=-1;
  string e1,e2;
  char aa;
  if(a[0]=='-')a="0"+a;
  for(q1=c5=0;q1<a.sz;q1++)
    {if(a[q1]=='(')c5++;
    if(a[q1]==')')c5--;
    if(c5!=0)continue;
    if(a[q1]=='+'&&c1==-1)c1=q1;
    if(a[q1]=='-')c2=q1;
    if(a[q1]=='*'&&c3==-1)c3=q1;
    if(a[q1]=='/')c4=q1;}

  c5=-1;
  if(c1!=-1){c5=c1;aa='+';}
  else if(c2!=-1)
    {if(a[c2-1]=='*'||a[c2-1]=='/'||a[c2-1]=='-'||a[c2-1]=='+')
      {a+="+0";
      e1=a.substr(0,c2);
      string e3;
      for(q1=c2+1,c5=0;q1<a.sz;q1++)
        {e3.pb(a[q1]);
        if(a[q1]=='(')c5++;
        if(a[q1]==')')c5--;
        if(c5==0&&(a[q1+1]<'0'||a[q1+1]>'9'))
          {e2=a.substr(q1+1);
          break;}}
      e1=e1+"(-"+e3+")"+e2;
      return eval(e2,x);}
    c5=c2;
    aa='-';}
  else if(c3!=-1){c5=c3;aa='*';}
  else if(c4!=-1){c5=c4;aa='/';}
  else
    {if(a[0]=='('&&a[a.sz-1]==')')
       return eval(a.substr(1,a.sz-2),x);
    if(a[0]=='x')return x;
    sscanf(a.cs,"%d",&c5);
    return (double)c5;}

  e1=a.substr(0,c5);
  e2=a.substr(c5+1);
  double f1,f2;
  f1=eval(e1,x);
  f2=eval(e2,x);
  if(f1>inf||f2>inf)return inf*(rand()+54352);
  if(aa=='+')f1=f1+f2;
  if(aa=='-')f1=f1-f2;
  if(aa=='/')
    {if(eq(f2,0.0)==1)return inf*(rand()+4353);
    f1=f1/f2;}
  if(aa=='*')f1=f1*f2;
  return f1;}

string inp;

int sq(expr aa)
  {double a,b,c,d,c1,c2;
  a=aa.a;b=aa.b;c=aa.c;
  if(a<0){a=-a;b=-b;c=-c;}
  d=b*b-4*a*c;
  if(d>0||eq(d,0.0))
    {c1=(-b-sqrt(d))/2.0/a,c2=(-b+sqrt(d))/2.0/a;
    if(!eq(eval(inp,c1),0.0))c1=inf;
    if(!eq(eval(inp,c2),0.0))c2=inf;
    if(c1+c2>inf*1.5)printf("none\n");
    else if(c1+c2>inf*0.5)
      {if(c1<inf*0.5)printf("%.4lf\n",c1);
      if(c2<inf*0.5)printf("%.4lf\n",c2);}
    else printf("%.4lf %.4lf\n",c1,c2);}
  else if(d<0&&(!eq(d,0.0)))
    printf("none\n");
  return 0;}
int lin(expr aa)
  {double a,b;
  a=aa.b;b=aa.c;
  if(eq(eval(inp,-b/a),0.0))printf("%.4lf\n",-b/a);
  else printf("none\n");
  return 0;}


char d[100];
int main()
  {fn=in;

  while(fscanf(fn,"%s",&d)!=EOF)
    {
    string s1=inp=d;
    frac f1=parse(s1+"+0");
    expr e1=f1.a;

    if((!e1)==2)sq(e1);
    else if((!e1)==1)lin(e1);
    else if((!e1)==0)printf("none\n");
    else if((!e1)==-1)printf("lots\n");

 //   print(f1);

    e1=e1;}

  fclose(fn);
  return 0;}
