#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<sstream>
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()
///////////////////////////////////////////
#define PI 3.1415926535897932384626433832795
#define eps 1e-8
#define in fopen("c:\\tp\\tests\\noi\\atom.10.in","r")
FILE*fn;

struct point
{
double x,y;
point (){x=y=0.0;};
point (double a,double b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

struct lineeq{double a,b,c;};

bool eq(double a,double b){if(a-b<eps&&b-a<eps)return 1;return 0;}
int get(double a)
  {if(eq(a,0.0))return 0;else if(a>0.0)return 1;else return -1;}

point operator!(const point&a){return point(-a.y,a.x);}
point operator^(const point&a,const double&b){return point(cos(b)*a.x-sin(b)*a.y,sin(b)*a.x+cos(b)*a.y);}
point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
double operator%(const point&a,const point&b){return hypot(a.x-b.x,a.y-b.y);}
point operator*(double a,const point&b){return point(a*b.x,a*b.y);}
point operator*(const point&b,double a){return point(a*b.x,a*b.y);}
double operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
bool operator==(const point&a,const point&b){return eq(a.x,b.x)&&eq(a.y,b.y);}

bool operator||(const line&a,const line&b)
  {return eq((a.b-a.a)^(b.a-a.a),(a.b-a.a)^(b.b-a.a));}
bool operator>(const line&a,const line&b)
  {int s1=get((a.b-a.a)^(b.a-a.a));
  int s2=get((a.b-a.a)^(b.b-a.a));
  if(s1*s2<=0)return 1;
  else return 0;}


lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}

lineeq findeq(line&a)
  {return findeq2(a.a.x,a.a.y,a.b.x,a.b.y);}

point operator^(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point fc(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point operator*(const line&a,const line&b)
  {double t=((a.a-b.b)^(b.a-b.b))/((a.b-a.a)^(b.a-b.b));
  return a.a-t*(a.b-a.a);}

double det2(point a,point b,point c)
  {return (b-a)^(c-a);}

point scanpoint(void)
  {point a;
  fscanf(fn,"%lf %lf",&a.x,&a.y);
  return a;}

///////////////////////////////////////////////////////////////////////

vector < point > all;
vector < line > hull;

int insidehull(point a)
  {
  for(int q1=0;q1<hull.sz;q1++)
    if(det2(hull[q1].a,hull[q1].b,a)<-eps)return 0;
  return 1;
  }

int buildhull(void)
  {
  int q1,q2,q3;
  vector < point > red;
  
  for(q1=0;q1<all.sz;q1++) 
    {
    int bad=0;
    for(q2=0;q2<all.sz;q2++)if(q2!=q1)
      for(q3=q2+1;q3<all.sz;q3++)if(q3!=q1)if(q3!=q2)
        if( eq(all[q2]%all[q1]+all[q1]%all[q3],all[q2]%all[q3]) )
           bad=1;
    if(bad==0)red.pb(all[q1]); 
    }
  for(q1=0;q1<red.sz;q1++)for(q2=q1+1;q2<red.sz;q2++)
    {
    int c[2];
    c[0]=c[1]=0;
    
    for(q3=0;q3<red.sz;q3++)if(q3!=q2&&q3!=q1)if(det2(red[q1],red[q2],red[q3])<0)c[0]++;else c[1]++;
    
    if(c[0]==0)hull.pb(line(red[q1],red[q2]));
    if(c[1]==0)hull.pb(line(red[q2],red[q1]));
    }
  return 0;
  }

line sym(line a)
  {point p1,p2;
  p1=0.5*(a.a+a.b);
  p2=(!(a.b-p1))+p1;
  return line(p1,p2);}

point center(point a,point b,point c)
  {
  line s1,s2;
  s1=sym(line(a,b));
  s2=sym(line(a,c));
  return s1*s2;
  }
  
int c,q1,q2,q3;
point p1,best;
line l1,l2;
double c1,c2,c3,res=0.0;

double closest(point a)
  {
  double mn=1e100;
  for(int q1=0;q1<all.sz;q1++)
    {
    if(mn>(a%all[q1]))mn=all[q1]%a;
    if(mn<res)break;
    }
  return mn;
  }

int main()
  {
  fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)all.pb(scanpoint());
  fclose(fn);
  
  buildhull();
  printf("gfdgfd\n");
  for(q1=0;q1<c;q1++)for(q2=q1+1;q2<c;q2++)for(q3=q2+1;q3<c;q3++)
    {
    l1=line(all[q1],all[q2]);
    l2=line(all[q1],all[q3]);
    if(l1||l2)continue;
    p1=center(all[q1],all[q2],all[q3]);
    if(!insidehull(p1))continue;
    c1=closest(p1);
    if(c1<res)continue;
    res=c1;
    best=p1;
    }
  for(q1=0;q1<c;q1++)for(q2=q1+1;q2<c;q2++)for(q3=0;q3<hull.sz;q3++)
    {
    l1=sym(line(all[q1],all[q2]));
    l2=hull[q3];
    if(l1||l2)continue;
    p1=l1*l2;
    if(!insidehull(p1))continue;
    c1=closest(p1);
    if(c1<=res)continue;
    res=c1;
    best=p1;
    }
  
  printf("%lf\n%lf %lf\n",res,best.x,best.y);
  return 0;}