#include<stdio.h>
#include<math.h>
#define PI acos(-1.0)
#define eps 1e-8
FILE*fn;
typedef struct{double x,y;}point;
typedef struct{double x,y,r;point p;}circle;
double dist2(point a,point b)
  {return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));}
double dist22(double a,double b)
  {return sqrt(a*a+b*b);}
double ABS(double a){if(a<0.0)return -a;else return a;}
point rot(point a,point b,double ang,double neww)
  {point p1,p2;
  double c1,cosa=cos(ang),sina=sin(ang);
  p1.x=b.x-a.x;
  p1.y=b.y-a.y;
  p2.x=p1.x*cosa-p1.y*sina;
  p2.y=p1.x*sina+p1.y*cosa;
  c1=dist2(a,b);
  if(neww<0.0)neww=c1;
  p2.x=p2.x*(neww/c1);
  p2.y=p2.y*(neww/c1);
  p2.x+=a.x;
  p2.y+=a.y;
  return p2;}
double det22(double a,double b,double c,double d)
  {return a*d-b*c;}
double det2(point a,point b,point c)
  {return det22(b.x-a.x,b.y-a.y,c.x-a.x,c.y-a.y);}
double area(point a,point b,point c)
  {double c1,c2,c3,c4;
  c1=dist2(a,b);
  c2=dist2(b,c);
  c3=dist2(c,a);
  c4=(c1+c2+c3)/2.0;
  return sqrt(c4*(c4-c1)*(c4-c2)*(c4-c3));}
int c,q1;
double c1,c2,c3,c4;
point p1,p2,p3,p4,a,b;
circle cc;
double sol(point aa,point bb)
  {double c1,c2;
  aa.x-=cc.x;
  aa.y-=cc.y;
  bb.x-=cc.x;
  bb.y-=cc.y;
  c1=atan2(aa.x,aa.y);
  c2=atan2(bb.x,bb.y);
  c1-=c2;
  if(c1<0.0)c1=-c1;
  if(c1>PI)c1=2.0*PI-c1;
  c2=c1*cc.r;  
  return dist2(a,aa)+dist2(b,bb)+c2;}
int main()
  {scanf("%d",&c);
  for(q1=0;q1<c;q1++)
    {scanf("%lf %lf %lf %lf %lf",&a.x,&a.y,&b.x,&b.y,&cc.r);
    cc.x=cc.y=cc.p.x=cc.p.y=0.0;
    a.x-=cc.x;
    b.x-=cc.x;
    a.y-=cc.y;
    b.y-=cc.y;
    c1=area(a,b,cc.p);
    if(dist2(a,b)<eps)
      {printf("%.3lf\n",0.0);
      continue;}
    c2=c1*2.0/dist2(a,b);
    if(c2>=cc.r)
      {printf("%.3lf\n",dist2(a,b));
      continue;}
    c3=c2/dist2(a,cc.p);
    c3=acos(c3);
    c4=det2(a,b,cc.p);
    if(c4<=0.0)c3=-c3;
    p1=rot(cc.p,a,c3,c2);
    c1=dist2(p1,a)+dist2(p1,b);
    c2=dist2(a,b);
    if(ABS(c1-c2)>eps)
      {printf("%.3lf\n",dist2(a,b));
      continue;}
    if(ABS(dist2(a,cc.p)-cc.r)>eps)
      {c1=cc.r/dist2(cc.p,a);
      c1=acos(c1);
      p1=rot(cc.p,a,c1,cc.r);
      p2=rot(cc.p,a,-c1,cc.r);}
    else p1=p2=a;

    if(ABS(dist2(b,cc.p)-cc.r)>eps)
      {c1=cc.r/dist2(cc.p,b);
      c1=acos(c1);
      p3=rot(cc.p,b,c1,cc.r);
      p4=rot(cc.p,b,-c1,cc.r);}
    else p3=p4=b;

    c1=sol(p1,p4);
    c2=sol(p2,p3);
    if(c1>c2)c1=c2;
    printf("%.3lf\n",c1);}
  
  return 0;}