#include<stdio.h>
#include<math.h>
#define eps 1e-10
#define inf 1e10

struct point
{
double x,y;
point (){x=y=0.0;};
point (double a,double b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

struct lineeq{double a,b,c;};

bool eq(double a,double b){if(a-b<eps&&b-a<eps)return 1;return 0;}

point operator*(const point&b,const double&a){return point(a*b.x,a*b.y);}
point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
double operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
bool operator||(const line&a,const line&b){return eq((a.b-a.a)^(b.a-a.a),(a.b-a.a)^(b.b-a.a));}
double dist22(point a,point b){return sqrt( (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y) );}


lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}

lineeq findeq(const line&a)
  {return findeq2(a.a.x,a.a.y,a.b.x,a.b.y);}

point operator^(const line&a,const line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point fc(const line&a,const line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}
  
point operator*(const line&a,const line&b)
  {double t=((a.a-b.b)^(b.a-b.b))/((a.b-a.a)^(b.a-b.b));
  return a.a-(a.b-a.a)*t;}

point rot90(point a)
  {return point(-a.y,a.x);}  
  
point p1,p2,p3,p4,p5;
line l1,l2,l3;

int main()
  {
  while(scanf("%lf %lf %lf %lf %lf %lf",&p1.x,&p1.y,&p2.x,&p2.y,&p3.x,&p3.y)==6)
    {
    p4=(p1+p2)*0.5;
    l1=line(p4,rot90(p1-p4)+p4);
    p5=(p1+p3)*0.5;
    l2=line(p5,rot90(p1-p5)+p5);
    p4=l1*l2;
    printf("%.2lf\n",(dist22(p4,p1))*2.0*3.141592653589793);
  //  if(!eq(dist2(p1,p4),dist22(p2,p4)))printf("ERRROR\n");
  //  if(!eq(dist2(p3,p4),dist22(p2,p4)))printf("ERRROR\n");
    }
  return 0;}
