#include<cstdio>
#include<cmath>
#include<cstdlib>
#include<sstream>
#include<map>
#include<vector>
#include<string>
#include<algorithm>
using namespace std;
 
#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()

#define type long long

struct rat
  {
  type num,den;
  rat() {num=0;den=1;};
  rat(type a) {num=a;den=1;};
  rat(type a,type b) {num=a;den=b;};
  };

type gcd(type a,type b){if(b==0)return a;else return gcd(b,a%b);}
type dif(const rat&a,const rat&b){return a.num*b.den-a.den*b.num;}
bool operator<(const rat&a,const rat&b){type c1=dif(a,b);return c1<0;}
bool operator<=(const rat&a,const rat&b){type c1=dif(a,b);return c1<=0;}
bool operator>(const rat&a,const rat&b){type c1=dif(a,b);return c1>0;}
bool operator>=(const rat&a,const rat&b){type c1=dif(a,b);return c1>=0;}
bool operator==(const rat&a,const rat&b){type c1=dif(a,b);return c1==0;}
bool operator!=(const rat&a,const rat&b){type c1=dif(a,b);return c1!=0;}

rat reduce(rat a){type c1=gcd(a.num,a.den);return rat(a.num/c1,a.den/c1);}
rat operator+(const rat&a,const rat&b)
  {return reduce(rat(a.num*b.den+a.den*b.num,a.den*b.den));}
rat operator-(const rat&a,const rat&b)
  {return reduce(rat(a.num*b.den-a.den*b.num,a.den*b.den));}
rat operator*(const rat&a,const rat&b)
  {return reduce(rat(a.num*b.num,a.den*b.den));}
rat operator/(const rat&a,const rat&b)
  {return reduce(rat(a.num*b.den,a.den*b.num));}
  
struct point
{
rat x,y;
point() {};
point (rat a,rat b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

 int get(rat a)
  {if(a==0)return 0;else if(a>0)return 1;else return -1;}

point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
bool operator==(const point&a,const point&b){return a.x==b.x && b.y==a.y;}
bool operator<(const point&a,const point&b){return a.x<b.x || (a.x==b.x && a.y<b.y);}
rat operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
point operator*(const rat&a,const point&b){return point(a*b.x,a*b.y);}

bool operator||(const line&a,const line&b)
  {return ((a.b-a.a)^(b.a-a.a))==((a.b-a.a)^(b.b-a.a));}
bool operator>(const line&a,const line&b)
  {int s1=get((a.b-a.a)^(b.a-a.a));
  int s2=get((a.b-a.a)^(b.b-a.a));
  if(s1*s2<=0)return 1;
  else return 0;}


point operator*(const line&a,const line&b)
  {rat t=((a.a-b.b)^(b.a-b.b))/((a.b-a.a)^(b.a-b.b));
  return a.a-(t*(a.b-a.a));}

bool lie(point a,line b)
  {(b||line(a,b.a))&&(a.x>=min(b.a.x,b.b.x))&&(a.x<=max(b.a.x,b.b.x))&&(a.y>=min(b.a.y,b.b.y))&&(a.y>=max(b.a.y,b.b.y));}

int pp(point p)
  {
  printf("%lld/%lld  %lld/%lld",p.x.num,p.x.den,p.y.num,p.y.den);
  return 0;
  }
int pl(line a)
  {
  pp(a.a);printf("    ");
  pp(a.b);printf("\n");
  return 0;}


line com;

bool common(line a,line b)
  {
  if(!(a||b))return false;
  if(!(a>b))return false;
  if(!(b>a))return false;
//  printf("gfdgfd\n");
  com.a=max(max(a.a,a.b),max(b.a,b.b));
  com.b=min(min(a.a,a.b),min(b.a,b.b));
//  pl(a);
 // pl(b);
 // pl(com);
 // printf(" result :           \n");
  rat c1,c2;
  c1=max(max(a.a.x,a.b.x),max(b.a.x,b.b.x))-min(min(a.a.x,a.b.x),min(b.a.x,b.b.x));
  c2=max(a.a.x,a.b.x)-min(a.a.x,a.b.x)+max(b.a.x,b.b.x)-min(b.a.x,b.b.x);
  if(c1>c2)return false;
  c1=max(max(a.a.y,a.b.y),max(b.a.y,b.b.y))-min(min(a.a.y,a.b.y),min(b.a.y,b.b.y));
  c2=max(a.a.y,a.b.y)-min(a.a.y,a.b.y)+max(b.a.y,b.b.y)-min(b.a.y,b.b.y);
  if(c1>c2)return false;
 // printf("OK\n");
  return true;}

vector < line > lines;
map < point , int > pois;
vector < point > points;
type c,q1,q2,q3,q4,c1,c2,c3,c4;
point p1,p2,p3,p4;
line l1,l2,l3;
VI v;

vector < VI > see;

int ins(point p)
  {
  if(pois.find(p)==pois.end())
    {pois[p]=points.sz;
    points.pb(p);}
  return pois[p];
  }

int dfs(int a,line l)
  {
  int c1=0,q1,q2;
  v[a]=1;
  for(q1=0;q1<c;q1++)if(!v[q1])if(common(l,lines[q1]))
    {
    dfs(q1,com);
    c1++;
    }
  
  if(c1)return 0;
  
  VI al;
  al.clear();
//  pl(l);
  for(q1=0;q1<points.sz;q1++)
    {
    //if(lie(points[q1],l))
    line b=l;
    point a=points[q1];
    if((b||line(a,b.a))&&(a.x>=min(b.a.x,b.b.x))&&(a.x<=max(b.a.x,b.b.x))&&(a.y>=min(b.a.y,b.b.y))&&(a.y<=max(b.a.y,b.b.y)))
      {al.pb(q1);
   //   pl(line(a,b.a));
      }
    }
  
//  for(q1=0;q1<al.sz;q1++)printf("%d ",al[q1]);
//  printf("\n");
  
  for(q1=0;q1<al.sz;q1++)for(q2=0;q2<al.sz;q2++)
    {
   // printf("                 %d %d\n",al[q1],al[q2]);
    see[al[q1]][al[q2]]=1;
    }
  return 0;}

int main()
  {
  scanf("%lld",&c);
  for(q1=0;q1<c;q1++)
    {
    scanf("%lld %lld %lld %lld",&l1.a.x.num,&l1.a.y.num,&l1.b.x.num,&l1.b.y.num);
    lines.pb(l1);
    
    ins(l1.a);
    ins(l1.b);
    }
  
  for(q1=0;q1<c;q1++)for(q2=q1+1;q2<c;q2++)if(lines[q1]>lines[q2] && lines[q2]>lines[q1])
    {
    if(lines[q1]||lines[q2])continue;
    p1=lines[q1]*lines[q2];
    ins(p1);
    }
  
  see.resize(points.sz,VI(points.sz,0));
  v.resize(lines.sz,0);
  for(q1=0;q1<c;q1++)if(!v[q1])dfs(q1,lines[q1]);
  
  c=points.sz;
  
  c1=0;
  for(q1=0;q1<c;q1++)for(q2=q1+1;q2<c;q2++)if(see[q1][q2])for(q3=q2+1;q3<c;q3++)if(see[q2][q3])if(see[q3][q1])
    {
    point a=points[q1];
    line b=line(points[q2],points[q3]);
    if(!(b||line(a,b.a)))
      c1++;
    }
  
//  for(q1=0;q1<c;q1++){pp(points[q1]);printf("\n");}
  
  for(q1=0;q1<c;q1++)
    {
 //   for(q2=0;q2<c;q2++)printf("%d",see[q1][q2]);
   // printf("\n");
    }
  
  printf("%lld\n",c1);
  return 0;}