/*
  Implementacja przykadowego modulu HSM dla zawodnika w C/C++
  Autor: Tomek Czajka
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

//#include "hsm.h"

static int zainicjowany = 0;

static int zaszyfrowany[4];
static int zapytania = 0;

static void inicjuj() {
  int i,x;
  char buf[100];
  
  //printf("Podaj zaszyfrowany numer karty (szesnastkowo): ");
  buf[0]='8';
  buf[1]='9';
  buf[2]='a';
  buf[3]='b';

  scanf("%s",buf);
  if(strlen(buf)<4) {
    printf("Za krotki\n");
    exit(1);
  }
  for(i=0;i<4;++i) {
    if(buf[i]>='0' && buf[i]<='9') x=buf[i]-'0';
    else if(buf[i]>='a' && buf[i]<='f') x=buf[i]-'a'+10;
    else if(buf[i]>='A' && buf[i]<='F') x=buf[i]-'A'+10;
    else {
      printf("Zla litera\n");
      exit(1);
    }
    zaszyfrowany[i] = x;
  }
  zainicjowany = 1;
}

int sprawdz(int p[], int a[]) {
  int i;
  
  if(!zainicjowany) inicjuj();
  
  ++zapytania;

  for(i=0;i<4;++i) {
    if(p[i]<0 || p[i]>9) {
      printf("PIN spoza zakresu\n");
      exit(1);
    }
  }
  for(i=0;i<16;++i) {
    if(a[i]<0 || a[i]>9) {
      printf("element tablicy konwersji spoza zakresu\n");
      exit(1);
    }
  }
  
  for(i=0;i<4;++i) {
    if(p[i] != a[zaszyfrowany[i]])
      return 0;
  }
  return 1;
}

void wynik(int p[]) {
  int i;
  int a[16];
  
  for(i=0;i<16;++i) a[i]=i%10;
  if(sprawdz(p,a)) printf("OK\n");
  else printf("ZLE\n");
  --zapytania;
  printf("Liczba zapytan: %d\n", zapytania);
  exit(0);
}



//#include "hsm.h"

int pos[10000],cc;
int p[10000][4];


int ss[16];

int check(int*a,int b)
  {int q1,c1=0;
  for(q1=0;q1<4;q1++)
    if(a[p[b][q1]])c1=c1*2+1;
    else c1=c1*2;
  return c1;}

int ask(void)
  {
  int s[16];
  int s2[4];
  int q1,q2,q3,c1,c2,c3,b1,b2,best=0;

  printf("%d\n",cc);

  for(q1=0;q1<(1<<10);q1++)
    {
    for(q2=0;q2<16;q2++)s[q2]=(q1&(1<<(q2%10)))/(1<<(q2%10));

    for(q2=0;q2<16;q2++)ss[q2]=0;
    for(q2=0;q2<cc;q2++)
      ss[check(s,pos[q2])]++;

    for(q2=0;q2<16;q2++)
      {c2=ss[q2];
      if(c2>cc-c2)c2=cc-c2;
      if(c2>best)
        {best=c2;
        b1=q2;
        b2=q1;}
      }
    }

  for(q2=0;q2<16;q2++)s[q2]=(b2&(1<<(q2%10)))/(1<<(q2%10));

  s2[0]=s2[1]=s2[2]=s2[3]=0;
  if(b1&8)s2[0]=1;
  if(b1&4)s2[1]=1;
  if(b1&2)s2[2]=1;
  if(b1&1)s2[3]=1;


  /*for(q1=0;q1<16;q1++)printf("%d",s[q1]);
  printf("   ");for(q1=0;q1<4;q1++)printf("%d",s2[q1]);
  printf("   %d %d %d\n",b1,b2,best);
    */
  c1=sprawdz(s2,s);

 // printf("%d\n",c1);

  c2=0;

  if(c1)
    {for(q1=0;q1<cc;q1++)if(check(s,pos[q1])==b1)
    pos[c2++]=pos[q1];}
  else
    {for(q1=0;q1<cc;q1++)if(check(s,pos[q1])!=b1)
    pos[c2++]=pos[q1];}
  cc=c2;  

  return 0;}


int q1,q2,q3,c1,c2;
int main()
  {
  for(q1=0;q1<10000;q1++)
    {pos[cc++]=q1;
    c1=q1;
    for(q2=0;q2<4;q2++)
      {p[q1][q2]=c1%10;
      c1/=10;}
    }
  while(cc>1)
    ask();
  wynik(p[pos[0]]);
  return 0;}
