/*
Svetoslav Kolev
English Language School Geo Milev - Rousse

Reshenie na zadacha 5 ot konkursa John Atanasov.

Zadachata se svezhda do tova: ako imame edna okryzhnost i N dygi s dylzhina 1, po kolko nachina mozhem 
da ia pokriem s dygi s dylzhina 2 i 3. Tia puk ot svoia strana se svezhda do systata zadacha , no ako 
imame otsechka a ne okryzhnost, samo che s malko promeni: moshem da sloshim otsechka (dyga) s dylzhina 3
taka che 2 edinici ot neia da sa v nachaloto na otsechkata, a 1 v kraia; moshem da sloshim otsechka 
(dyga) s dylzhina 3 taka che 1 edinici ot neia da sa v nachaloto na otsechkata, a 2 v kraia; moshem da 
sloshim otsechka (dyga) s dylzhina 3 taka che 3 edinici ot neia da sa v nachaloto na otsechkata, a 0
v kraia (t.e. tia ne se razcepva). Imame 2 analogichni sluchai s otsechak s dylshina 2 (tova simulira 
slagane po okryshnost). Ako sme sloshili otsechkata 3 taka che 2 edinici da sa v kraia a 1 v nachaloto 
togava v nezaetoto prostranstvo moshem da slagame kakvoto si iskame (otsechki s dylzhina 2 ili 3). 
A to e dylgo N-3. Vyvezhdam si funkcia S(x) koiato kazva po kolko nachina moshem da zapulnim otsechka 
s dylshina x s dygi 2 ili 3. Poneshe imame 3 sluchaia s otsechka s dylshina 3 i 2 sluchaia s otsechka 
s dylshina 2 (t.e. da gi postaviame taka che da zastypvat kraia i nachaloto na otsechkata s dylshina N)
to reshenieto na zadachata e  3*S(N-3)+2*S*(N-2), zastoto kato sloshim edna otsechka s dylshina 3 v 
ostavat N-3 svobodni, i analogichno s 2. Sega ostava da smetnem funkciata S().Lesno se zabeliazva che 
S(x)=S(x-2)+S(x-3). Sega ostava da smetnem tazi funkcia i posle da izvedem otgovora. POneshe stoinostta
na otgovora raste eksponenzialno, az ia smiatam po modul 'mod', koito e definiran v nachaloto na progra-
mata mi. Sloshnostta na tova reshenie e O(n), zastoto se systoi samo v presmiatane na S(x), a s dinamich-
no programirane moshem lesno da si zapulnem edin masiv.

Podobrenie na sloshnostta. Ste pokazha kak  moshe zadachata da byde reshena s O(logN) sloshnost, no 
pri uslovie che smiatam rezultata po modul 'mod' (inache ne moshe da byde postignata takava sloshnost).
Imame edin vektor (matrica 1XN) s dylshina N=3 (0,1,1). Imame i edna matrica 3X3 
(0,0,1)
(1,0,1)
(0,1,0).
Poneshe i vektoryt e matrica to moshem da gi umnoshim i v rezultat ste poluchim slednia vector (1,1,1)
Ako si predstavim che vektoryt (a,b,c) sa tri posledovatelni stoinosti na S() primerno S(d),S(d+1),S(d+2)
to ako go umnoshim s tazi matrica se poluchava vectoryt (b,c,a+b), koeto syotvetstva na S(d+1),S(d+2),S(d+3).
Taka s umnoshenieto mu s matricata poluchavame sledvastata stoinost. Ako priloshim tazi operacia N puti ste
poluchim reshenieto za vsichki S(i) ot 1 do N. No ima i po byrz nachin. POneshe niama znachenie v kakyv red 
ste izvyrshvame umnosheniata na matricite, moshem purvo da povdignem matricata na shelanata stepen i posle
da ia umnoshim s vectora. A ima izvesten algoritum za povdigane na nesto na stepen sys sloshonost 
LOG(n)*(sloshnost na umnoshenieto). Poneshe v nashia sluchai matricata e s konstantni razmeri, tazi slosnost
e O(1) => cialata sloshnost e  O(LogN).

Vhodyt se chete ot standartnia vhod i se izveshda na standartnia izhod.

Pri vyveshdane na N <10 000 000 se puskat i dvata algorityma. A pri n >10 000 000 samo po byrzia.

Programata raboti za N < 2^63.

Modulyt triabva da byde po maluk ot 2^29 inache pri umnoshenieto v matricite st se poluchi prepulvane.
*/
#include<stdio.h>
#define mx 10000009
#define mod 500000000
#define in stdin;//fopen("c:\\tp\\tests\\5.in","r")
FILE*fn;
typedef struct {long long m[3][3];}m3x;
m3x one={{{0,0,1},{1,0,1},{0,1,0}}};
m3x mul(m3x a,m3x b)
  {m3x c;
  long long q1,q2,q3;
  for(q1=0;q1<3;q1++)for(q2=0;q2<3;q2++)c.m[q1][q2]=0;
  for(q1=0;q1<3;q1++)for(q2=0;q2<3;q2++)for(q3=0;q3<3;q3++)
    c.m[q1][q2]=(c.m[q1][q2]+a.m[q1][q3]*b.m[q3][q2])%mod;
  return c;}
m3x calc(long long a)
  {m3x e1,e2;
  if(a==1)return one;
  if(a%2==0)
    {e1=calc(a/2);
    return mul(e1,e1);}
  if(a%2==1)
    {e1=calc(a-1);
    return mul(e1,one);}
  return e1;}
int calc2(long long a)
  {m3x ok;
  long long c1;
  if(a<2)return 0;
  else if(a<5)return 1;
  ok=calc(a-3);
  c1=ok.m[1][2];
  c1+=ok.m[2][2];
  return c1%mod;}
long long ss[mx];
long long q1,c,ans;
int main()
  {fn=in;
  fscanf(fn,"%lld",&c);
  fclose(fn);
  if(c<10000000)
    {ss[0]=1;
    ss[2]=1;
    for(q1=3;q1<=c;q1++)ss[q1]=(ss[q1-2]+ss[q1-3])%mod;
    ans=3*ss[c-3];
    ans+=2*ss[c-2];
    ans=ans%mod;
    if(c==2||c==3)ans=1;
    printf("result from the linear algorithm - %lld\n",ans);}
  ans=3*calc2(c-3);
  ans+=2*calc2(c-2);
  ans=ans%mod;
  if(c==2||c==3)ans=1;
  printf("result from the logarithmic algo - %lld\n",ans);
  return 0;}
