#include<stdio.h>
#include<stdlib.h>
#define in fopen("lists.inp","r")
#define ut fopen("lists.out","w")
FILE*fn;

#define MAXN 1048576
#define MAXNODES 324288
#define inputsize 4000000
#define type int
#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))
#define SWAP(a,b) swap(&(a),&(b))
#define NOT(a) a=1-(a)
#define left 0
#define right 1

typedef struct __node{int h,rev,sum; type mx,mn; union { struct __node* c[2]; struct { struct __node *l,*r;};  }; }node;
typedef struct { union { node* c[2]; struct { node *l,*r;}; }; } pair;

inline int swap(node**a,node**b){node*c;c=*a;*a=*b;*b=c;return 0;}

inline int rep(node*a)
  {if(a->l==NULL)return 0;
  a->sum=a->l->sum+a->r->sum;
  a->h=MAX(a->l->h,a->r->h)+1;
  a->mx=MAX(a->l->mx,a->r->mx);
  a->mn=MIN(a->l->mn,a->r->mn);
  return 0;}
  

inline int push(node*a)
  {if(a->rev==1)
    {swap(&(a->l),&(a->r));
    NOT(a->l->rev);
    NOT(a->r->rev);
    a->rev=0;
    return 1;}
  return 0;}


int lr(node**a,int b)
  {node *p1,*p2,*p3;
  p1=*a;
  p2=p1->c[b];
  p3=p2->c[1-b];
  push(p3);
  p2->c[1-b]=p3->c[b];
  p1->c[b]=p3->c[1-b];
  p3->c[b]=p2;
  p3->c[1-b]=p1;
  *a=p3;
  rep(p1);rep(p2);rep(p3);
  return 1;}
  
int ll(node**a,int b)
  {node *p1,*p2;
  p1=*a;
  p2=p1->c[b];
  p1->c[b]=p2->c[1-b];
  p2->c[1-b]=p1;
  *a=p2;
  rep(p1);rep(p2);
  return 1;}
  
int rot(node**c,int a,int b)
  {if(push(*c))a=1-a;
  if(push((*c)->c[a]))b=1-b;
  if(a!=b)
    lr(c,a);
  else 
    ll(c,a);
  return 1;}

node nodeheap[MAXNODES];
int counter;

inline node* make_node(void)
  {return nodeheap+counter++;}


int check(node**a,int b)
  {
  if((*a)->c[b]->h-2>=(*a)->c[1-b]->h)
    return rot(a,b,(*a)->c[b]->c[1]->h>(*a)->c[b]->c[0]->h );
  return 0;}

int balance(node**a)
  {int c1;
  
  if((*a)->l==NULL)return (*a)->rev=0;
  
  c1=(*a)->c[1]->h>(*a)->c[0]->h;
  while(check(a,c1));
 
  return 0;}


node* merge2(node**a,node**b)
  {node*nw;
  nw=make_node();
  nw->l=*a;
  nw->r=*b;
  rep(nw);
  *a=nw;
  *b=NULL;
  balance(a);
  return *a;}


pair d;

int split(node**a,int b)
  { 
  push(*a);
    
  if((*a)->l->sum==b)
    {d.l=(*a)->l;
    d.r=(*a)->r;
    *a=NULL;
    return 0;}
  
  if((*a)->l->sum>b)
    {split(&((*a)->l),b);
    (*a)->l=d.r;
    d.r=*a;}
  else
    {split(&((*a)->r),b-(*a)->l->sum);
    (*a)->r=d.l;
    d.l=*a;}
  rep(*a);
  return 0;}

////////////////////////////////////////////////////////////////////////////////


int go(node*a,int rev)
  {if(a==NULL)return 0;
  if(a->l==NULL)printf("%d ",a->mx);
  go(a->c[(a->rev+rev)%2],(rev+a->rev)%2);
  go(a->c[(a->rev+rev+1)%2],(rev+a->rev)%2);
  return 0;}



node*ss[MAXN];

inline int CREATE(int a,int b)
  {
  ss[a]=make_node();
  ss[a]->sum=1;
  ss[a]->mx=ss[a]->mn=b;
  
  return 0;}

inline int MERGE(int a,int b)
  {
  ss[a]=merge2(&ss[a],&ss[b]);
  
  return 0;}

inline int SPLIT(int a,int b,int c)
  {
  split(&ss[a],b-1);
  ss[a]=d.l;
  ss[c]=d.r;
  
  return 0;}
  
inline int REVERSE(int a)
  {
  ss[a]->rev=1-ss[a]->rev;
  
  return 0;} 
  
inline int findMIN(int a){return ss[a]->mn;}
inline int findMAX(int a){return ss[a]->mx;}


int c1,c2,c3;



char dd[inputsize];
char*pointer,ddd;

int readinput(void)
  {int q1;
  fn=in;
  fread(dd,1,inputsize,fn);
  fclose(fn);
  for(q1=0;dd[q1];q1++)
    if(dd[q1]==' '||dd[q1]=='\n')dd[q1]=0;
  pointer=dd;
  return 0;}

inline int geti(void)
  {int c1=0;
  for(;*pointer;pointer++)
    c1=c1*10+(*pointer)-48;    
  pointer++;
  return c1;}

int main()
  {
  readinput();
  
  fn=ut;
  
  while(1)
    {
    ddd=pointer[2];

         if(ddd=='e'){pointer+=7;c1=geti();c2=geti();}
    else if(ddd=='r'){pointer+=6;c1=geti();c2=geti();}
    else if(ddd=='l'){pointer+=6;c1=geti();c2=geti();c3=geti();}
    else if(ddd=='v'){pointer+=8;c1=geti();}
    else if(ddd=='n'){pointer+=4;c1=geti();}
    else if(ddd=='x'){pointer+=4;c1=geti();}
    else if(ddd=='o')break;
    
         if(ddd=='e')CREATE(c1,c2);
    else if(ddd=='r')MERGE(c1,c2);
    else if(ddd=='l')SPLIT(c1,c2,c3);
    else if(ddd=='v')REVERSE(c1);
    else if(ddd=='n')fprintf(fn,"%d\n",findMIN(c1));
    else if(ddd=='x')fprintf(fn,"%d\n",findMAX(c1));
    else if(ddd=='o')break;
    }  

  fclose(fn);

  return 0;}
