#include<stdio.h>
#include<memory.h> 
#include<string.h>
#include<stdlib.h>
#include<time.h>
#include<ctype.h>

#define max(a,b) ((a)>(b)?(a):(b))
#define min(a,b) ((a)<(b)?(a):(b))
#define lb 9
#define hashsize 77777
#define memhashsize 777777
#define maxoutput 777
#define maxoutputhashsize 7777777
typedef unsigned int ui;

/////// memory leakage checking
long long malloc_calls;
long long malloc_allocated;
long long free_calls;
long long free_freed;
long long mem_leaks1;
typedef struct __mem{ui ptr,size;struct __mem*next;} memhash;
memhash*mh[memhashsize]; 
memhash mhh[memhashsize];
char mhhfree[memhashsize];
int mhhptr;

void*mem_malloc(void);
int mem_free(void*a);
int mem_hash(ui a);
int mem_hash_put(ui a,ui b);
int mem_hash_find(ui a);
int mem_hash_delete(ui a);
int mem_hash_change(ui a1,ui a2,ui b);

void*mmalloc(int a);
int mfree(void*a);
void*mrealloc(void*a,int b);

//////checking functions
int iswhite(char a);
int is_number(char*a);
int is_number2(char*a,int b);
int is_dig(char a,int b);
int is_var(char*a);
int is_int(char*a);
int is_base(char*a);

/////memory management
int mem_char_put(char**a,int*size,int*l,char b);
int mem_string_put(char***a,int*size,int*l,char*s1,int len);
int mem_string_free(char***a,int*l);
int mem_string_print(char**a,int l);

//////input
char getnonwhite(void);
char getwhatever(void);
char getconverted(void);
char*readexp(void);

//////parser
int funs=9;
int f[9][2]={{2,1},{0,2},{0,3},{1,4},{1,5},{2,6},{2,7},{2,0},{0,8}};
char names[9][10]={"define","help","mem","set","print","print","base","expt","exit"};
int args[9][2]={{2,0},{0,0},{0,0},{3,0},{0,0},{0,3},{3,0},{0,1},{0,0}};
int parse(char*a,int expected,char**ans);
int parse1(char*a,int expected,char**ans);
int buildexp(char**dest,char**parsed,int len);
char*getnextexp(char**a);

/////////// big num
typedef struct {int c;int*ss;} Ltype;
typedef Ltype* L;
int base=1;

L zero,one;
L l_new(int a);
L l_create(int a);
int l_delete(L a);
int l_copy(L from,L to);
L l_copy2(L from);
int l_initialize(void);
int l_compress(L a);
int l_normalize(L a);
L l_add(L a,L b);
L l_sub(L a,L b);
int l_dif(L a,L b);
int l_gr(L a,L b);
int l_greq(L a,L b);
int l_ls(L a,L b);
int l_lseq(L a,L b);
int l_eq(L a,L b);
int l_noteq(L a,L b);
L l_mul(L a,L b);
L l_muln(L a,int b);
int l_print(L a);  
int l_print2(L a); 
int l_iszero(L a);
L l_read(char*a,int start,int end,int*b,int*exptt,int bas);
int l_dump(L a);

//////////// rational numbers
typedef struct {int sign,exp;L num,den;} Qtype;
typedef Qtype* Q;
Q q_zero,q_one;
Q q_new(void);
Q q_create(int a);
Q q_create2(L n,L d,int exp1,int sign);
int q_delete(Q a);
Q q_copy(Q from);
int q_initialize(void);
int q_normalize(Q a);
Q q_add(Q a,Q b);
Q q_sub(Q a,Q b);
int q_dif(Q a,Q b);
int q_gr(Q a,Q b);
int q_greq(Q a,Q b);
int q_ls(Q a,Q b);
int q_lseq(Q a,Q b);
int q_eq(Q a,Q b);
int q_noteq(Q a,Q b);
Q q_mul(Q a,Q b);
Q q_div(Q a,Q b);
int q_reciproc(Q a);
Q q_muln(Q a,int b);
int q_print(Q a); 
int q_iszero(Q a);
int q_dump(Q a);

//////////// output numbers
typedef struct {int c;char*ss;} Otype;
typedef Otype* O;
int obase=10;
O o_zero,o_one;

O o_new(int a);
O o_create(int a);
int o_delete(O a);
O o_copy(O from);
int o_initialize(void);
int o_compress(O a);
O o_add(O a,O b);
O o_sub(O a,O b);
int o_dif(O a,O b);
int o_gr(O a,O b);
int o_greq(O a,O b);
int o_ls(O a,O b);
int o_lseq(O a,O b);
int o_eq(O a,O b);
int o_noteq(O a,O b);
O o_muln(O a,int b);
int o_print(O a);  
O convert(L aa,int b);
char*o_divide(O aa,O bb,int*start,int*end,int*len);

//////////// output hash
typedef struct {O a;int pos;} outh;
outh oh[maxoutput];
int ohin;

int ohinit(void);
int output_hash(O a);
int output_hash_put(O a,int pos);
int output_hash_find(O a);
int ohrelease(void);

//////////// number operators
#define type Q

type num_copy(type a);
type num_create(int a);
int num_delete(type a);
type num_read_type(char*a,int start,int end);
int num_print_type(type a,int b,int c);

////// numeric functions
int num_reciproc(type a);
type num_mul(type a,type b);
type num_add(type a,type b);
type num_div(type a,type b);
type num_dif(type a,type b);
type num_power(type a,int p);

///////////// variable hash
typedef struct {char*a;type n;} hash_type;
hash_type*h[hashsize];
int var_hash(char*a);
int var_hash_put(char*a,type b);
type var_hash_get(char*a);
int var_hash_find(char*a);
int var_hash_memory(int*br);

///////////// advanced numeric functions
int l_rem(L a,int b);
L l_divint(L a,int b);
int l_doit(L a,int b,int w);
L l_gcd(L aa,L bb);
L l_longdiv(L aa,L bb);

/////////// eval
int basis;
int  eval_expt_int  (char*a,int start,int end);
type eval_expt_type (char*a,int start,int end);
type eval_expt      (char*a,int start,int end);
type eval           (char*a,int start,int end);
type eval_get_first (char*a,int start,int end);
type eval_get_second(char*a,int start,int end);

char*process_define_getname(char*a);
char*process_define_getexp(char*a);
int process_define(char*a);
int process_help(char*a);
int process_exp(char*a);
int process_mem(char*a);
int process_set(char*a);
int process_print1(char*a);
int process_print2(char*a);
int process_base(char*a);
int process_error(char*a);

int initialize(void);

int main()
  {
  initialize();
  char *d1,*d2,*d3;
  int t,q1,q2;
 // freopen("c:\\edu\\csp1\\in.txt","r",stdin);  d1=readexp();
  
  
  malloc_calls=0;
  free_calls=0;
  malloc_allocated=0;
  free_freed=0;
    
  while(1)
    {
    printf("> ");
    d1=readexp();
    double t1=clock();
    t=parse(d1,-1,&d2);
    int flag=0;
    
    if(t==8)break;
    if(t==7)process_base(d2);
    if(t==6)process_print2(d2);
    if(t==5)process_print1(d2);
    if(t==4)process_set(d2);
    if(t==3)flag=3;
    if(t==2)process_help(d2);
    if(t==1)process_define(d2);
    if(t==0)process_exp(d2);
    if(t==-1)process_error(d2);
    mfree(d1);
    if(mem_hash_find((ui)d2))mfree(d2);
    
    if(flag==3)process_mem(d2);
    
//    process_mem(d2);printf("%lf\n",(clock()-t1)/CLOCKS_PER_SEC);
    }
  
 // system("pause");
  return 0;}

int initialize(void)
  {int q1;
  for(q1=0;q1<lb;q1++)base=base*10;
  basis=10;
  obase=10;
  l_initialize();
  q_initialize();
  o_initialize();
  return 0;}

int iswhite(char a)
  {if(a==' '||a=='\n'||a=='\t')return 1;return 0;}
char getnonwhite(void)
  {char a=' ';
  while(iswhite(a))a=getc(stdin);
  return a;}
char getwhatever(void)
  {char a=getc(stdin);
  return a;}
char getconverted(void)
  {char a;
  a=getc(stdin);
  if(iswhite(a))
    {a=getc(stdin);
    if(!iswhite(a))
      {ungetc(a,stdin);
      return ' ';}}
  return a;}
int mem_char_put(char**a,int*size,int*l,char b)
  {if(*l==(*size)-1)
    {*a=(char*)mrealloc(*a,(*size)*2*sizeof(char));
    memset((*a)+(*size),0,(*size)*sizeof(char));
    (*size)*=2;}
  (*a)[(*l)++]=b;
  return 0;}
char*readexp(void)
  {
  char*ans;
  int l=0,s=4;
  ans=(char*)mmalloc(sizeof(char)*s);
  memset(ans,0,sizeof(char)*s);
  char a1,a2;
  a1=getnonwhite();
  if(a1!='(')
    {while(!iswhite(a1))
      {mem_char_put(&ans,&s,&l,a1);
      a1=getwhatever();}
    return ans;}
  int dep=1;
  mem_char_put(&ans,&s,&l,a1);
  while(dep)
    {a1=getconverted();
    mem_char_put(&ans,&s,&l,a1);
    if(a1=='(')dep++;
    if(a1==')')dep--;}
  return ans;}

int is_dig(char a,int b)
  {int c1=-1;
  if(a>='0'&&a<='9')c1=a-48;
  if(a>='A'&&a<='Z')c1=a-55;
  if(c1<0||c1>=b)return 0;
  return 1;}

int is_number2(char*a,int b)
  {if(a==NULL)return 0;
  if(a[0]==0)return 0;
  if(a[0]=='-' || a[0]=='+')if(a[1]!='-' && a[1]!='+')return is_number(a+1);
  int q1;
  for(q1=0;a[q1];q1++)if(!(is_dig(a[q1],b)||a[q1]=='.'))return 0;
  return 1;}
int is_number(char*a)
  {int q1,q2,c1,c2;
  c1=strlen(a);
  if(a[c1-1]==']')
    {for(q1=c1-2;q1>=0;q1--)if(a[q1]=='[')break;
    if(q1<=0)return 0;
    if(((c1-q1)!=3) && ((c1-q1)!=4))return 0;
    if(c1-q1==4)c2=(a[q1+1]-48)*10+a[q1+2]-48;
    else c2=a[q1+1]-48;
    if(c2<2||c2>36)return 0;
    a[q1]=0;
    c1=is_number2(a,c2);
    a[q1]='[';
    return c1;}
  else return is_number2(a,basis);}
int is_var(char*a)
  {int q1;
  for(q1=0;a[q1];q1++)if((!isalpha(a[q1])) || a[q1]<'a')return 0;
  return 1;}
int is_int(char*a)
  {char d[16];
  int b;
  sscanf(a,"%d",&b);
  sprintf(d,"%d",b);
  if(!strcmp(a,d))return 1;
  return 0;}

int is_base(char*a)
  {if(is_int(a))
    {int c1;
    sscanf(a,"%d",&c1);
    if(c1>=2 && c1<=36)return 1;}
  return 0;}

int mem_string_put(char***a,int*size,int*l,char*s1,int len)
  {if(*l==(*size))
    {*a=(char**)mrealloc(*a,(*size)*2*sizeof(char*));
    memset((*a)+(*size),0,(*size)*sizeof(char*));
    (*size)*=2;}
  (*a)[*l]=(char*)mmalloc(sizeof(char)*len+1);
  memset((*a)[*l],0,sizeof(char)*len+1);
  memcpy((*a)[*l],s1,len*sizeof(char));
  (*l)++;
  return 0;}
int mem_string_free(char***a,int*l)
  {int q1;
  for(q1=0;q1<*l;q1++)mfree((*a)[q1]);
  mfree(*a);
  *a=0;
  return 0;}
int mem_string_print(char**a,int l)
  {int q1;
  printf("\n%d\n",l);
  for(q1=0;q1<l;q1++)printf("%s\n",a[q1]);
  return 0;}
char*getnextexp(char**a)
  {  
  for(;**a;(*a)++)if(!iswhite(**a))break;
  if(**a==0)return 0;
  
  char*ans;
  int l=0,s=4;
  ans=(char*)mmalloc(sizeof(char)*s);
  memset(ans,0,sizeof(char)*s);
  if(**a=='(')
    {int dep=1;
    mem_char_put(&ans,&s,&l,**a);
    while(1)
      {(*a)++;
      if(**a=='(')dep++;
      if(**a==')')dep--;
      mem_char_put(&ans,&s,&l,**a);
      if(dep==0)break;}
    (*a)++;
    return ans;}
  else
    {mem_char_put(&ans,&s,&l,**a);
    while(1)
      {(*a)++;
      if(**a=='(')break;
      if(**a==')')break;
      if(**a==' ')break;
      if(**a==0)break;
      mem_char_put(&ans,&s,&l,**a);}
    return ans;}
  return 0;}
int buildexp(char**dest,char**parsed,int len)
  {
  char*ans;
  int l=0,s=4;
  ans=(char*)mmalloc(sizeof(char)*s);
  memset(ans,0,sizeof(char)*s);
  int q1,q2;
  
  if(strcmp("+",parsed[0])&&strcmp("-",parsed[0])&&strcmp("/",parsed[0])&&strcmp("*",parsed[0]))
    {mem_char_put(&ans,&s,&l,'(');
    mem_char_put(&ans,&s,&l,' ');
    for(q1=0;q1<len;q1++)
      {for(q2=0;parsed[q1][q2];q2++)mem_char_put(&ans,&s,&l,parsed[q1][q2]);
      mem_char_put(&ans,&s,&l,' ');}
    mem_char_put(&ans,&s,&l,')');
    *dest=ans;
    return 0;}
  
  for(q1=0;q1<len-2;q1++)
    {mem_char_put(&ans,&s,&l,'(');
    mem_char_put(&ans,&s,&l,' ');
    mem_char_put(&ans,&s,&l,parsed[0][0]);
    mem_char_put(&ans,&s,&l,' ');}
  
  for(q2=0;parsed[1][q2];q2++)mem_char_put(&ans,&s,&l,parsed[1][q2]);
  
  for(q1=2;q1<len;q1++)
    {mem_char_put(&ans,&s,&l,' ');
    for(q2=0;parsed[q1][q2];q2++)mem_char_put(&ans,&s,&l,parsed[q1][q2]);
    mem_char_put(&ans,&s,&l,' ');
    mem_char_put(&ans,&s,&l,')');}
  *dest=ans;
  return 0;}

int parse1(char*a,int expected,char**ans)
  {(*ans)=0;
  if(a[0]!='(')
    {if(expected==1)if(!is_int(a))return -1;
    if(expected==2)if(!is_var(a))return -1;
    if(expected==3)if(!is_base(a))return -1;
    if(expected==0 || expected==-1)if(!is_number(a))if(!is_var(a))return -1;
    *ans=(char*)mmalloc(sizeof(char)*strlen(a)+1);
    strcpy(*ans,a);
    return 0;}
  if(expected==2||expected==1||expected==3)return -1;
  char**parsed;
  int s=4,l=0;
  parsed=(char**)mmalloc(sizeof(char*)*s);
  memset(parsed,0,sizeof(char*)*s);
  char**ready;
  int sr=4,lr=0;
  ready=(char**)mmalloc(sizeof(char*)*sr);
  memset(ready,0,sizeof(char*)*sr);
  a++;
  a[strlen(a)-1]=0;
  char*token;
  while((token=getnextexp(&a))!=NULL)
    {mem_string_put(&parsed,&s,&l,token,strlen(token));
    mfree(token);
    token=0;}
 // mem_string_print(parsed,l);
  if(l==0)return -1;
  mem_string_put(&ready,&sr,&lr,parsed[0],strlen(parsed[0]));
  int q1,q2,ff;
  
  for(q1=0;q1<funs;q1++)if(!strcmp(names[q1],parsed[0]))if(l-1==f[q1][0])break;
  if(q1==funs)if(strcmp("+",parsed[0])&&strcmp("-",parsed[0])&&strcmp("/",parsed[0])&&strcmp("*",parsed[0]))
    {mem_string_free(&parsed,&l);mem_string_free(&ready,&lr);
    return -1;}
  else goto arith;
  ff=q1;
  if( (ff==7 && expected!=-1 && expected!=0) || (ff!=7 && expected!=-1))
    {mem_string_free(&parsed,&l);mem_string_free(&ready,&lr);
    return -1;}
  for(q1=0;q1<f[ff][0];q1++)
    {char*atoken;
    int out;
    out=parse(parsed[q1+1],args[ff][q1],&atoken);
    if(out==-1)
      {mem_string_free(&parsed,&l);mem_string_free(&ready,&lr);
      return -1;}
    mem_string_put(&ready,&sr,&lr,atoken,strlen(atoken));
    mfree(atoken);}
  
  buildexp(ans,ready,lr);
  mem_string_free(&parsed,&l);mem_string_free(&ready,&lr);
  return f[ff][1];
  arith:
  if(!strcmp("-",parsed[0]))if(l==2)mem_string_put(&ready,&sr,&lr,"0",1);
  if(!strcmp("/",parsed[0]))if(l==2)mem_string_put(&ready,&sr,&lr,"1",1);
  for(q1=1;q1<l;q1++)
    {
    char*atoken;
    int out;
    out=parse(parsed[q1],0,&atoken);
    if(out==-1)
      {mem_string_free(&parsed,&l);mem_string_free(&ready,&lr);
      return -1;}
    mem_string_put(&ready,&sr,&lr,atoken,strlen(atoken));
    mfree(atoken);
    }
  while(lr<3)
    {if(strcmp("+",parsed[0])==0 || strcmp("-",parsed[0])==0)mem_string_put(&ready,&sr,&lr,"0",1);
    if(strcmp("*",parsed[0])==0 || strcmp("/",parsed[0])==0)mem_string_put(&ready,&sr,&lr,"1",1);}
  buildexp(ans,ready,lr);
  mem_string_free(&parsed,&l);mem_string_free(&ready,&lr);
  return 0;}
int parse(char*a,int expected,char**ans)
  {int ret=parse1(a,expected,ans);
  if(a[0]=='(')a[strlen(a)]=')';
  return ret;}
  
type num_copy(type a)
  {return q_create2(a->num,a->den,a->exp,a->sign);}
type num_create(int a)
  {return q_create(a);}
int num_delete(type a)
  {q_delete(a);
  return 0;}
type num_read_type(char*a,int start,int end)
  {int sign,exptt=0,c1=end+1,c2=basis,q1=end+1,q2;
  if(a[end]==']')
    {for(q1=end-1;q1>=start;q1--)if(a[q1]=='[')break;
    if(c1-q1==4)c2=(a[q1+1]-48)*10+a[q1+2]-48;
    else c2=a[q1+1]-48;
    if(c2<2||c2>36)return 0;
    a[q1]=0;}
  
  L e1=l_read(a,start,q1-1,&sign,&exptt,c2);
  L e2=l_create(1);
  for(q1=0;q1<exptt;q1++)
    {L e3=l_muln(e2,c2);
    l_delete(e2);
    e2=l_copy2(e3);
    l_delete(e3);}
  Q c=q_create2(e1,e2,0,sign);
  l_delete(e1);
  l_delete(e2);
  //q_dump(c);
  if(a[end]==']')a[q1]='[';
  return c;}
int num_print_type(type aa,int b,int c)
  {
  if(l_iszero(aa->den))
    {if(l_iszero(aa->num))
      {printf("indeterminate\n");
      return 0;}
    if(aa->sign==-1)printf("-");else printf("+");
    printf("inf\n");return 0;}
  int q1,q2,q3,c1,c2,c3;
  L num,den,gcd,e1,e2;
  num=l_copy2(aa->num);
  den=l_copy2(aa->den);
  if(aa->exp<0)for(q1=0;q1<-aa->exp;q1++)
    {L e1=l_muln(den,10);
    l_delete(den);
    den=l_copy2(e1);
    l_delete(e1);}
  else for(q1=0;q1<aa->exp;q1++)
    {L e1=l_muln(num,10);
    l_delete(num);
    num=l_copy2(e1);
    l_delete(e1);}
  
  gcd=l_gcd(num,den);
  e1=l_longdiv(num,gcd);
  l_delete(num);
  num=l_copy2(e1);
  l_delete(e1);
  e1=l_longdiv(den,gcd);
  l_delete(den);
  den=l_copy2(e1);
  l_delete(e1);
  
  obase=b;
  O numo=convert(num,b);
  O deno=convert(den,b);
  int start=-1,end=-1,l=0;
  char*ans=o_divide(numo,deno,&start,&end,&l);
  
  //o_print(numo);o_print(deno);for(q1=0;q1<l;q1++)if(ans[q1]<10)printf("%d",ans[q1]);else printf("%c",55+ans[q1]);printf("  %d %d\n",start,end);
  if(aa->sign==-1)if(!l_iszero(aa->num))printf("-");
  for(q1=0;q1<numo->c;q1++)if(ans[q1])break;
  if(q1==numo->c)q1--;
  for(;q1<numo->c;q1++)
    if(ans[q1]<10)printf("%d",ans[q1]);else printf("%c",55+ans[q1]);
  if(start==-1)
    {printf(".");
    for(q1=numo->c;q1<l;q1++)if(ans[q1]<10)printf("%d",ans[q1]);else printf("%c",55+ans[q1]);
    printf("....");
    if(c)printf("[%d]",b);
    printf(" too long to display\n");}
  else if(start!=end || ans[start]!=0)
    {printf(".");
    for(q1=numo->c;q1<start;q1++)if(ans[q1]<10)printf("%d",ans[q1]);else printf("%c",55+ans[q1]);
    printf("(");
    for(q1=start;q1<=end;q1++)if(ans[q1]<10)printf("%d",ans[q1]);else printf("%c",55+ans[q1]);
    printf(")");
    if(c)printf("[%d]",b);
    printf("\n");}
  else if(ans[start]==0 && start==end && start!=numo->c)
    {printf(".");
    for(q1=numo->c;q1<start;q1++)if(ans[q1]<10)printf("%d",ans[q1]);else printf("%c",55+ans[q1]);
    if(c)printf("[%d]",b);
    printf("\n");}
  else 
    {if(c)printf("[%d]",b);
    printf("\n");}
  
  mfree(ans);
  o_delete(numo);
  o_delete(deno);
  l_delete(num);
  l_delete(den);
  l_delete(gcd);
  return 0;} 

int num_reciproc(type a)
  {return q_reciproc(a);}
  
type num_mul(type a,type b)
  {return q_mul(a,b);}
type num_add(type a,type b)
  {return q_add(a,b);}
type num_div(type a,type b)
  {return q_div(a,b);}
type num_dif(type a,type b)
  {return q_sub(a,b);}
  
type num_power(type a,int p)
  {type ret=num_create(1),t;
  int c1=p>0?p:-p;
  int q1;
  for(q1=0;q1<c1;q1++)
    {
    t=num_mul(ret,a);
  //  q_dump(t);
    num_delete(ret);
    ret=t;}
  if(p<0)num_reciproc(ret);
  return ret;}

int var_hash(char*a)
  {int c1=0,q1;
  for(q1=0;a[q1];q1++)c1=(c1*113+a[q1])%hashsize;
  return c1;}
int var_hash_put(char*a,type b)
  {int c1=var_hash(a);
  while(h[c1])
    if(!strcmp(a,h[c1]->a))break;else c1=(c1+1)%hashsize;
  if(h[c1]==NULL)
    {h[c1]=(hash_type*)mmalloc(sizeof(hash_type));
    h[c1]->a=(char*)mmalloc((strlen(a)+1)*sizeof(char));
    strcpy(h[c1]->a,a);
    if(b)h[c1]->n=num_copy(b);
    else h[c1]->n=num_create(0);}
  else 
    {num_delete(h[c1]->n);
    if(b)h[c1]->n=num_copy(b);
    else h[c1]->n=num_create(0);}
  return 0;}
type var_hash_get(char*a)
  {int c1=var_hash(a);
  while(h[c1])if(!strcmp(a,h[c1]->a))break;else c1=(c1+1)%hashsize;
  if(h[c1]==NULL)
    {h[c1]=(hash_type*)mmalloc(sizeof(hash_type));
    h[c1]->a=(char*)mmalloc((1+strlen(a))*sizeof(char));
    strcpy(h[c1]->a,a);
    h[c1]->n=num_create(1);}
  type ret=num_copy(h[c1]->n);
  return ret;}

int var_hash_find(char*a)
  {int c1=var_hash(a);
  while(h[c1])if(!strcmp(a,h[c1]->a))break;else c1=(c1+1)%hashsize;
  if(h[c1]==NULL)return 0;
  return 1;}
  
//typedef struct {char*a;type n;} hash_type;
//hash_type*h[hashsize];

int var_hash_memory(int*br)
  {int q1,c1=0;
  for(q1=0;q1<hashsize;q1++)if(h[q1])
    {c1+=mem_hash_find((ui)h[q1]);
    c1+=mem_hash_find((ui)h[q1]->a);
    c1+=mem_hash_find((ui)h[q1]->n);
    c1+=mem_hash_find((ui)h[q1]->n->num);
    c1+=mem_hash_find((ui)h[q1]->n->den);
    c1+=mem_hash_find((ui)h[q1]->n->num->ss);
    c1+=mem_hash_find((ui)h[q1]->n->den->ss);
    *br+=7;}
  return c1;}

int process_help(char*a)
  {printf("\nWelcome to the arbitrary precision scheme arithmetic expressions evaluator.\n\n");
  printf("Major features: supports defining variables, addition, subtraction, multiplication and division* of rational** numbers. ");
  printf("Internally all numbers are stored with their full precision as rational numbers, and upon displaying it tries to display ");
  printf("them in lossless format if possible (if the resulting number can be outputted with less than __maxoutput__ (currently set ");
  printf("to %d) digits). For example the result of (/ 1 3) will be 0.(3).\n\n",maxoutput);
  printf("Help on individual functions:\n\n");
  printf("(define var_name expression) : ");
  printf("defines a variable called var_name and having value of expression. If a variable is accessed without being defined first ");
  printf("its value is assumed 1.\n\n");
  printf("(help) : prints this text.\n\n");
  printf("(mem) : prints memory leaks checks.\n\n");
  printf("(exit) : exits the program.\n\n");
  printf("(expt expression power) : power must be number that can be stored (including negative values) in signed int (32 bit).\n\n");
  printf("(print expression b) : prints expression in base b. the second argument can be omitted. In this case it prints the value ");
  printf("in the default base which is initially set to 10. b must be an integer written in base10 and having a value in [2..36].\n\n");
  printf("(base b expression) : same as (print expression b).\n\n");
  printf("(set b) : changes the default base to b. b must be an integer written in base10 and having a value in [2..36].\n\n");
  printf("To enter number in a number system B, write the number as (-)xxxxxxx[B]\n. Ommiting the [B] assumes the default.\n");
  printf("Letters used in numbers are only uppercase. In variables they are only lowercase.\n\n");
  printf("Remarks: no memory leaks identified, but some strange things happen when dealing with long numbers.\n");
  printf("If you see 'deletion of nonexistent pointer' means that i am calling free with a pointer that is not in my\n");
  printf("memory database. Unknown reason. But the program seems to work even then.\n");
  return 0;}
  
int eval_expt_int(char*a,int start,int end)
  {int q1,c1;
  for(q1=end-2;a[q1]!=' ';q1--);
  sscanf(a+q1+1,"%d",&c1);
  return c1;}
  
type eval_expt_type(char*a,int start,int end)
  {int q1;
  for(q1=end-2;;q1--)
    if(a[q1]==' ')break;
  return eval(a,start+7,q1-1);}
  
type eval_expt(char*a,int start,int end)
  {type b=eval_expt_type(a,start,end);
  int p=eval_expt_int(a,start,end);
  type ans=num_power(b,p);
  num_delete(b);
  return ans;}

type eval_get_first(char*a,int start,int end)
  {int q1,c1;
  for(q1=start+4,c1=0;;q1++)
    {if(a[q1]=='(')c1++;
    if(a[q1]==')')c1--;
    if(c1==0&&a[q1]==' ')break;}
  return eval(a,start+4,q1-1);}
type eval_get_second(char*a,int start,int end)
  {int q1,c1,c2;
  for(q1=start+4,c1=0;;q1++)
    {if(a[q1]=='(')c1++;
    if(a[q1]==')')c1--;
    if(c1==0&&a[q1]==' ')break;}
  c2=q1;
  for(q1++,c1=0;;q1++)
    {if(a[q1]=='(')c1++;
    if(a[q1]==')')c1--;
    if(c1==0&&a[q1]==' ')break;}
  return eval(a,c2+1,q1-1);}

type eval(char*a,int start,int end)
  {char*loc;
  loc=(char*)mmalloc((end-start+2)*sizeof(char));
  memset(loc,0,(end-start+2)*sizeof(char));
  memcpy(loc,a+start,end-start+1);
  if(loc[0]!='(')
    {if(is_number(loc)){mfree(loc);return num_read_type(a,start,end);}
    if(is_var(loc))
      {type ret=var_hash_get(loc);
      mfree(loc);
      return ret;}}
  if(loc[2]=='e'){mfree(loc);return eval_expt(a,start,end);}
  type aa=eval_get_first(a,start,end);
  type bb=eval_get_second(a,start,end);
  type res;
  if(loc[2]=='+')res=num_add(aa,bb);
  if(loc[2]=='*')res=num_mul(aa,bb);
  if(loc[2]=='-')res=num_dif(aa,bb);
  if(loc[2]=='/')res=num_div(aa,bb);
 // printf("%s\n",loc);
 // q_print(aa);
 // q_print(bb);
 // q_print(res);
  num_delete(aa);
  num_delete(bb);
  mfree(loc);
  return res;}

char*process_define_getname(char*a)
  {int q1,c3=0,c1,c2;
  for(q1=0;a[q1];q1++)
    {if(a[q1]==' ')c3++;
    if(c3==2)break;}
  c1=q1+1;
  for(q1=c1+1;a[q1]!=' ';q1++);
  c2=q1-1;
  char*ret;
  ret=(char*)mmalloc(sizeof(char)*(c2-c1+2));
  memset(ret,0,sizeof(char)*(c2-c1+2));
  for(q1=c1;q1<=c2;q1++)ret[q1-c1]=a[q1];
  return ret;}

char*process_define_getexp(char*a)
  {int q1,c3=0,c1,c2,dep=0;
  for(q1=0;a[q1];q1++)
    {if(a[q1]==' ')c3++;
    if(c3==3)break;}
  c1=q1+1;
  for(q1=c1;;q1++)
    {if(a[q1]=='(')dep++;
    if(a[q1]==')')dep--;
    if(dep==0&&a[q1]==' ')break;}
  c2=q1-1;
  char*ret;
  ret=(char*)mmalloc(sizeof(char)*(c2-c1+2));
  memset(ret,0,sizeof(char)*(c2-c1+2));
  for(q1=c1;q1<=c2;q1++)ret[q1-c1]=a[q1];
  return ret;}

int process_define(char*a)
  {
  char*var=process_define_getname(a);
  char*exp=process_define_getexp(a);
  
  if(!var_hash_find(a))
    {type t=num_create(1);
    var_hash_put(var,t);
    num_delete(t);}
  type res=eval(exp,0,strlen(exp)-1);
  var_hash_put(var,res);
  printf("%s = ",var);
  num_print_type(res,basis,0);
  mfree(var);
  mfree(exp);
  num_delete(res);
  return 0;}

int process_exp(char*a)
  {type ans=eval(a,0,strlen(a)-1);
  //L e1=l_longdiv(ans->num,ans->den);l_print(e1);l_delete(e1);
  num_print_type(ans,basis,0);
 // printf("\n");
  num_delete(ans);
  return 0;}

int process_mem(char*a)
  {int c1,c2=0;
  c1=var_hash_memory(&c2);
  printf("\n\nMemory statistics so far:\n\n");
  printf("Total malloc calls                            : %lld\n",malloc_calls);
  printf("Total calls to free                           : %lld\n",free_calls);
  printf("Total malloc calls used for variable storing  : %d\n",c2);
  printf("Total malloc calls leaked                     : %lld\n\n",malloc_calls-free_calls-c2);
  printf("Total memory allocated                  : %lld\n",malloc_allocated);
  printf("Total memory freed                      : %lld\n",free_freed);
  printf("Total memory used for variable storing  : %d\n",c1);
  printf("Total memory leaked                     : %lld\n\n",malloc_allocated-free_freed-c1);
  printf("Total memoty leaks detected other ways        : %d\n",mem_leaks1);
  return 0;}
int process_set(char*a)
  {int c1;
  sscanf(a+6,"%d",&c1);
  basis=c1;
  return 0;}
int process_print1(char*a)
  {type e1=eval(a,8,strlen(a)-3);
  num_print_type(e1,basis,0);
  num_delete(e1);
  return 0;}
int process_print2(char*a)
  {int q1,c1=0,c2;
  for(q1=strlen(a)-1;q1>=0;q1--)
    {if(a[q1]==' ')c1++;
    if(c1==2)break;}
  type e1=eval(a,8,q1-1);
  sscanf(a+q1+1,"%d",&c2);
  num_print_type(e1,c2,1);
  num_delete(e1);
  return 0;}
int process_base(char*a)
  {int q1,c1=0,c2;
  for(q1=0;;q1++)
    {if(a[q1]==' ')c1++;
    if(c1==3)break;}
  type e1=eval(a,q1+1,strlen(a)-3);
  sscanf(a+7,"%d",&c2);
  num_print_type(e1,c2,1);
  num_delete(e1);
  return 0;}
int process_error(char*a)
  {printf("\nParse Error. Try (help).\n\n");
  return 0;}
  

L l_new(int a)
  {L c;
  if(a<1)a=1;
  c=(L)mmalloc(sizeof(Ltype));
  c->c=a;
  c->ss=(int*)mmalloc(a*sizeof(int));
  memset(c->ss,0,a*sizeof(int));
  return c;}
L l_create(int a)
  {L c=l_new(1);
  c->ss[0]=1;
  L d=l_muln(c,a);
  l_delete(c);
  return d;}
int l_delete(L a)
  {mfree(a->ss);
  mfree(a);
  return 0;}
int l_copy(L from,L to)
  {to->c=from->c;
  if(to->ss)mfree(to->ss);
  to->ss=(int*)mmalloc(to->c*sizeof(int));
  memcpy(to->ss,from->ss,to->c*sizeof(int));
  return 0;}
L l_copy2(L from)
  {L to=l_new(0);
  to->c=from->c;
  mfree(to->ss);
  to->ss=(int*)mmalloc(to->c*sizeof(int));
  memcpy(to->ss,from->ss,to->c*sizeof(int));
  return to;}
int l_initialize(void)
  {zero=l_create(0);
  one=l_create(1);
  return 0;}
int l_compress(L a)
  {if(a->ss[0])return 0;
  int q1;
  for(q1=0;q1<a->c;q1++)if(a->ss[q1])break;
  if(q1==a->c)q1=a->c-1;
  L c=l_new(a->c-q1);
  memcpy(c->ss,a->ss+q1,c->c*sizeof(int));
  l_copy(c,a);
  l_delete(c);
  return 0;}
int l_normalize(L a)
  {
 // printf("normalize: ");l_dump(a);
  int c1,c2,c3,q1,c4;
  for(q1=a->c-1;q1>=0;q1--)if(a->ss[q1])break;
  if(q1==-1)return l_copy(zero,a);
  c1=(a->c-1-q1)*lb;
  c2=a->ss[q1];
  c3=1;
  while(c2%10==0)c1++,c2/=10,c3*=10;
  c2=a->c-1-q1;
  L c=l_new(a->c-c2);
  for(q1=c->c-1;q1>=0;q1--)
    {c4=a->ss[q1]/c3;
    if(q1)c4+=(base/c3)*(a->ss[q1-1]%c3);
    c->ss[q1]=c4;}
  l_compress(c);
  l_copy(c,a);
  l_delete(c);
 // printf("\nnormalize: ");l_dump(a);printf("\n\n");
  return c1;}
L l_add(L a,L b)
  {L c=l_new(max(a->c,b->c)+1);
  int q1,c1=0;
  for(q1=0;q1<c->c;q1++)
    {if(a->c-q1-1>=0)c1+=a->ss[a->c-q1-1];
    if(b->c-q1-1>=0)c1+=b->ss[b->c-q1-1];
    c->ss[c->c-1-q1]=c1%base;
    c1/=base;}
  l_compress(c);
  return c;}
L l_sub(L a,L b)
  {L c=l_new(1);
  l_copy(a,c);
  int q1,c1;
  for(q1=0;q1<c->c;q1++)
    {if(b->c-1-q1>=0)c1=b->ss[b->c-1-q1];else c1=0;
    if(c->ss[c->c-1-q1]<c1)
      {c->ss[c->c-1-q1]+=base;
      if(q1!=c->c-1)c->ss[c->c-2-q1]--;}
    c->ss[c->c-1-q1]-=c1;}
  l_compress(c);
  return c;}
int l_dif(L a,L b)
  {l_compress(a);
  l_compress(b);
  if(a->c>b->c)return 1;
  if(a->c<b->c)return -1;
  int q1;
  for(q1=0;q1<a->c;q1++)
    if(a->ss[q1]<b->ss[q1])return -1;
    else if(a->ss[q1]>b->ss[q1])return 1;
  return 0;}
int l_gr(L a,L b){return l_dif(a,b)>0;}
int l_greq(L a,L b){return l_dif(a,b)>=0;}
int l_ls(L a,L b){return l_dif(a,b)<0;}
int l_lseq(L a,L b){return l_dif(a,b)<=0;}
int l_eq(L a,L b){return l_dif(a,b)==0;}
int l_noteq(L a,L b){return l_dif(a,b)!=0;}

L l_mul(L a,L b)
  {L c=l_new(a->c+b->c);
  int q1,q2,q3;
  long long c1=0;
  for(q1=0;q1<a->c;q1++)for(q2=0;q2<b->c;q2++)
    {c1=(long long)a->ss[a->c-1-q1]*(long long)b->ss[b->c-1-q2];
    for(q3=0;c1;q3++)
      {c1+=c->ss[c->c-1-q1-q2-q3];
      c->ss[c->c-1-q1-q2-q3]=c1%base;
      c1/=base;}}
  l_compress(c);
  return c;}

L l_muln(L a,int b)
  {int q1;
  long long c1=0;
  L c=l_new(a->c+10);
  for(q1=a->c-1;q1>=0||c1!=0;q1--)
    {if(q1>=0)c1+=(long long)a->ss[q1]*(long long)b;
    c->ss[q1+10]=c1%base;
    c1/=base;}
  l_compress(c);
  return c;}

int l_print(L a)
  {int q1;
  for(q1=0;q1<a->c;q1++)if(a->ss[q1])break;
  if(q1==a->c)q1--;
  printf("%d",a->ss[q1]);
  for(q1++;q1<a->c;q1++)printf("%0*d",lb,a->ss[q1]);
  printf("\n");
  return 0;}
int l_print2(L a)
  {int q1;
  for(q1=0;q1<a->c;q1++)if(a->ss[q1])break;
  if(q1==a->c)q1--;
  printf("%d",a->ss[q1]);
  for(q1++;q1<a->c;q1++)printf("%0*d",lb,a->ss[q1]);
  return 0;}
int l_iszero(L a)
  {l_compress(a);
  if(a->c==1)if(a->ss[0]==0)return 1;
  return 0;}

L l_read(char*a,int start,int end,int*b,int*exptt,int bas)
  {if(a[start]=='-')*b=-1;else *b=1;
  int bo=0;
  if(a[start]=='-' || a[start]=='+')bo=1;else bo=0;
  *exptt=0;
  int c1,c2,c3;
  int q1;
  L c=l_create(0);
  c1=0;
  for(q1=start+bo;q1<=end;q1++)
    {
    if(a[q1]=='.')c1=1;
    else
      {(*exptt)+=c1;
      L d=l_muln(c,bas);
      l_delete(c);
      c=l_copy2(d);
      l_delete(d);
      d=l_create(a[q1]<='9'?a[q1]-48:a[q1]-55);
      L e=l_add(d,c);
      l_delete(c);
      l_delete(d);
      c=l_copy2(e);
      l_delete(e);}
    }
  return c;}

Q q_new(void)
  {Q c;
  c=(Q)mmalloc(sizeof(Qtype));
  c->exp=0;
  c->sign=1;
  c->num=l_create(0);
  c->den=l_create(1);
  return c;}
Q q_create(int a)
  {Q c;
  c=(Q)mmalloc(sizeof(Qtype));
  c->exp=0;
  if(a<0)c->sign=-1;else c->sign=1;
  c->num=l_create(a>0?a:a);
  c->den=l_create(1);
  return c;}
Q q_create2(L n,L d,int exp1,int sign)
  {Q c;
  c=(Q)mmalloc(sizeof(Qtype));
  c->exp=exp1;
  c->sign=sign;
  c->num=l_copy2(n);
  c->den=l_copy2(d);
  q_normalize(c);
  return c;}
  
int q_delete(Q a)
  {l_delete(a->num);
  l_delete(a->den);
  mfree(a);
  return 0;}
Q q_copy(Q from)
  {Q to=q_new();
  l_delete(to->num);
  l_delete(to->den);
  to->exp=from->exp;
  to->sign=from->sign;
  to->num=l_copy2(from->num);
  to->den=l_copy2(from->den);
  return to;}
int q_initialize()
  {q_zero=q_create(0);
  q_one=q_create(1);
  return 0;}
int q_normalize(Q a)
  {int c1=0;
  c1+=l_normalize(a->num);
  c1-=l_normalize(a->den);
  a->exp+=c1;
  return 0;}

int q_neg(Q a)
  {a->sign=-a->sign;
  return 0;}  
Q q_neg2(Q a)
  {Q c=q_copy(a);
  c->sign=-c->sign;
  return c;}

int q_mul10(Q a,int b)
  {int q1;
  for(q1=0;q1<b;q1++)
    {L c=l_muln(a->num,10);
    l_delete(a->num);
    a->num=l_copy2(c);
    l_delete(c);
    a->exp--;}
  return 0;}

Q q_add(Q a,Q b)
  {L e1,e2,e3,e4,e5;
  int c1,c2,c3;
  Q A,B,c;
  A=q_copy(a);
  B=q_copy(b);
  c1=max(A->exp,B->exp)-min(A->exp,B->exp);
  if(A->exp>B->exp)q_mul10(A,c1);
  else if(A->exp<B->exp)q_mul10(B,c1);
  e1=l_mul(A->num,B->den);
  e2=l_mul(A->den,B->num);
  e3=l_mul(A->den,B->den);
  e4=l_add(e1,e2);
  if(l_ls(e1,e2))e5=l_sub(e2,e1);else e5=l_sub(e1,e2);
  if(A->sign==-1)if(B->sign==-1)c=q_create2(e4,e3,A->exp,-1);
  if(A->sign== 1)if(B->sign== 1)c=q_create2(e4,e3,A->exp, 1);
  if(A->sign== 1)if(B->sign==-1)if(l_greq(e1,e2))c=q_create2(e5,e3,A->exp, 1);
  if(A->sign== 1)if(B->sign==-1)if(l_ls  (e1,e2))c=q_create2(e5,e3,A->exp,-1);
  if(A->sign==-1)if(B->sign== 1)if(l_ls  (e1,e2))c=q_create2(e5,e3,A->exp, 1);
  if(A->sign==-1)if(B->sign== 1)if(l_greq(e1,e2))c=q_create2(e5,e3,A->exp,-1);
  q_delete(A);
  q_delete(B);
  l_delete(e1);
  l_delete(e2);
  l_delete(e3);
  l_delete(e4);
  l_delete(e5);
  q_normalize(c);
  return c;}
  
Q q_sub(Q a,Q b)
  {Q c=q_neg2(b);
  Q d=q_add(a,c);
  q_delete(c);
  return d;}

int q_iszero(Q a)
  {if(l_iszero(a->num))return 1;
  return 0;}
int q_dif(Q a,Q b)
  {Q c=q_sub(a,b);
  if(q_iszero(c))return 0;
  int c1=c->sign;
  q_delete(c);
  return c1;}
int q_gr(Q a,Q b){return q_dif(a,b)>0;}
int q_greq(Q a,Q b){return q_dif(a,b)>=0;}
int q_ls(Q a,Q b){return q_dif(a,b)<0;}
int q_lseq(Q a,Q b){return q_dif(a,b)<=0;}
int q_eq(Q a,Q b){return q_dif(a,b)==0;}
int q_noteq(Q a,Q b){return q_dif(a,b)!=0;}
Q q_mul(Q a,Q b)
  {Q c;
  L e1,e2;
  e1=l_mul(a->num,b->num);
  e2=l_mul(a->den,b->den);
  c=q_create2(e1,e2,a->exp+b->exp,a->sign*b->sign);
  l_delete(e1);
  l_delete(e2);
  q_normalize(c);
  return c;}
Q q_div(Q a,Q b)
  {Q c,d;
  c=q_copy(b);
  q_reciproc(c);
  d=q_mul(a,c);
  q_delete(c);
  return d;}
int q_reciproc(Q a)
  {L b;
  b=a->den;
  a->den=a->num;
  a->num=b;
  a->exp=-a->exp;
  return 0;}
int q_print(Q a)
  {
  l_print2(a->num);
  printf(" / ");
  l_print2(a->den);
  printf("   exp: %d   sign: %d\n",a->exp,a->sign);
  //q_dump(a);
  return 0;}

int l_dump(L a)
  {int q1;
  printf("(%d)",a->c);
  for(q1=0;q1<a->c;q1++)printf(" %d",a->ss[q1]);
  return 0;}  

int q_dump(Q a)
  {l_dump(a->num);
  printf(" / ");
  l_dump(a->den);
  printf("  *10^%d  sign: %d\n",a->exp,a->sign);
  return 0;}
  
  
  
void*mem_malloc(void)
  {while(mhhfree[mhhptr])mhhptr=(mhhptr+1)%memhashsize;
  mhhfree[mhhptr]=1;
  return (char*)mhh+(mhhptr*sizeof(memhash));}
int mem_free(void*a)
  {int c1;
  c1=(char*)a-(char*)mhh;
  c1/=sizeof(memhash);
  mhhfree[c1]=0;
  return 0;}

int mem_hash(ui a)
  {unsigned long long c1=a;
  c1*=a;
  return c1%memhashsize;}
int mem_hash_put(ui a,ui b)
  {int c1=mem_hash(a);
  memhash*l=mh[c1];
  while(l)
    {if(l->ptr==a)break;
    l=l->next;}
  if(l)if(l->ptr==a)mem_leaks1++;
  if(l==0)
    {l=mh[c1];
    mh[c1]=(memhash*)mem_malloc();
    mh[c1]->next=l;
    l=mh[c1];}
  l->ptr=a;
  l->size=b;
  malloc_calls++;
  malloc_allocated+=b;
  return 0;}
int mem_hash_find(ui a)
  {int c1=mem_hash(a);
  memhash*l=mh[c1];
  while(l)
    {if(l->ptr==a)break;
    l=l->next;}
  if(l==0)return 0;
  return l->size;}
int mem_hash_delete(ui a)
  {int c1=mem_hash(a);
  memhash**l=&mh[c1];
  while(*l)
    {if((*l)->ptr==a)break;
    l=&((*l)->next);}
  if(*l==0){printf("deletion of a nonexistent pointer\n");return 0;}
  memhash*k=(*l)->next;
  free_calls++;
  free_freed+=(*l)->size;
  mem_free(*l);
  *l=k;
  return 0;}
int mem_hash_change(ui a1,ui a2,ui b)
  {malloc_allocated-=mem_hash_find(a1);
  free_freed-=mem_hash_find(a1);
  mem_hash_delete(a1);
  mem_hash_put(a2,b);
  malloc_calls--;
  free_calls--;
  return 0;}

void*mmalloc(int a)
  {void*b=malloc(a);
  mem_hash_put((ui)b,(ui)a);
  return b;}
int mfree(void*a)
  {mem_hash_delete((ui)a);
  free(a);
  return 0;}
void*mrealloc(void*a,int b)
  {void*c=realloc(a,b);
  mem_hash_change((ui)a,(ui)c,(ui)b);
  return c;}


///////// advanced numeric functions


int l_rem(L a,int b)
  {long long c1=0,q1;
  for(q1=0;q1<a->c;q1++)
    {c1+=a->ss[q1];
    c1=(c1%b)*base;}
  return c1/base;}

L l_divint(L a,int b)
  {L c=l_copy2(a);
  long long c1=0,q1;
  for(q1=0;q1<a->c;q1++)
    {c1+=a->ss[q1];
    c->ss[q1]=c1/b;
    c1=(c1%b)*base;}
  l_compress(c);
  return c;}

int l_doit(L a,int b,int w)
  {L e1;
  if(w==-1)e1=l_divint(a,b);
  else e1=l_muln(a,b);
  l_copy(e1,a);
  l_delete(e1);
  return 0;}

L l_gcd(L aa,L bb)
  {L a=l_copy2(aa),b=l_copy2(bb);
  L d=l_create(1),c;
  while(l_rem(a,2)==0 && l_rem(b,2)==0)
    {l_doit(a,2,-1);
    l_doit(b,2,-1);
    l_doit(d,2,1);}
  while(l_gr(a,zero))
    {if(l_rem(a,2)==0)l_doit(a,2,-1);
    else if(l_rem(b,2)==0)l_doit(b,2,-1);
    else
      {if(l_gr(a,b))c=l_sub(a,b);
      else c=l_sub(b,a);
      l_doit(c,2,-1);
      if(l_ls(a,b))
        {l_delete(b);
        b=l_copy2(c);}
      else
        {l_delete(a);
        a=l_copy2(c);}
      l_delete(c);}}
  L ans=l_mul(d,b);
  l_delete(d);
  l_delete(a);
  l_delete(b);
  return ans;}
  
  
L l_longdiv(L aa,L bb)
  {L c=l_copy2(aa),d,e,f,g,a=l_copy2(aa),b=l_copy2(bb);
  int q1,c1,c2,c3,l,m,r;
  d=l_create(0);
  for(q1=0;q1<c->c;q1++)
    {f=l_create(a->ss[q1]);
    g=l_muln(d,base);
    e=l_add(g,f);
    l_delete(g);
    l_delete(f);
    l_delete(d);
    d=l_copy2(e);
    l_delete(e);
    l=0;
    r=base-1;
    while(l!=r)
      {m=(l+r+1)/2;
      e=l_muln(b,m);
      //l_print(e);l_print(d);
      if(l_gr(e,d))r=m-1;
      else l=m;
      l_delete(e);}
    e=l_muln(b,l);
    f=l_sub(d,e);
    l_delete(d);
    l_delete(e);
    d=l_copy2(f);
    l_delete(f);
    
    c->ss[q1]=l;}
  l_delete(d);
  l_delete(a);
  l_delete(b);
  l_compress(c);
  return c;}

O o_new(int a)
  {O c;
  if(a<1)a=1;
  c=(O)mmalloc(sizeof(Otype));
  c->c=a;
  c->ss=(char*)mmalloc(sizeof(char)*a);
  memset(c->ss,0,a*sizeof(char));
  return c;}
O o_create(int a)
  {O c=o_new(1);
  c->ss[0]=1;
  O d=o_muln(c,a);
  o_delete(c);
  return d;}
int o_delete(O a)
  {mfree(a->ss);
  mfree(a);
  return 0;}
O o_copy(O from)
  {O to=o_new(0);
  to->c=from->c;
  mfree(to->ss);
  to->ss=(char*)mmalloc(to->c*sizeof(char));
  memcpy(to->ss,from->ss,to->c*sizeof(char));
  return to;}
int o_initialize(void)
  {o_zero=o_create(0);
  o_one=o_create(1);
  return 0;}
int o_compress(O a)
  {if(a->ss[0])return 0;
  int q1;
  for(q1=0;q1<a->c;q1++)if(a->ss[q1])break;
  if(q1==a->c)q1=a->c-1;
  O c=o_new(a->c-q1);
  memcpy(c->ss,a->ss+q1,c->c*sizeof(char));
  mfree(a->ss);
  a->c=c->c;
  a->ss=(char*)mmalloc(a->c*sizeof(char));
  memcpy(a->ss,c->ss,a->c*sizeof(char));
  o_delete(c);
  return 0;}
O o_add(O a,O b)
  {O c=o_new(max(a->c,b->c)+1);
  int q1,c1=0;
  for(q1=0;q1<c->c;q1++)
    {if(a->c-q1-1>=0)c1+=a->ss[a->c-q1-1];
    if(b->c-q1-1>=0)c1+=b->ss[b->c-q1-1];
    c->ss[c->c-1-q1]=c1%obase;
    c1/=obase;}
  o_compress(c);
  return c;}
O o_sub(O a,O b)
  {O c=o_copy(a);
  int q1,c1;
  for(q1=0;q1<c->c;q1++)
    {if(b->c-1-q1>=0)c1=b->ss[b->c-1-q1];else c1=0;
    if(c->ss[c->c-1-q1]<c1)
      {c->ss[c->c-1-q1]+=obase;
      if(q1!=c->c-1)c->ss[c->c-2-q1]--;}
    c->ss[c->c-1-q1]-=c1;}
  o_compress(c);
  return c;}
int o_dif(O a,O b)
  {o_compress(a);
  o_compress(b);
  if(a->c>b->c)return 1;
  if(a->c<b->c)return -1;
  int q1;
  for(q1=0;q1<a->c;q1++)
    if(a->ss[q1]<b->ss[q1])return -1;
    else if(a->ss[q1]>b->ss[q1])return 1;
  return 0;}
int o_gr(O a,O b){return o_dif(a,b)>0;}
int o_greq(O a,O b){return o_dif(a,b)>=0;}
int o_ls(O a,O b){return o_dif(a,b)<0;}
int o_lseq(O a,O b){return o_dif(a,b)<=0;}
int o_eq(O a,O b){return o_dif(a,b)==0;}
int o_noteq(O a,O b){return o_dif(a,b)!=0;}

O o_muln(O a,int b)
  {int q1;
  long long c1=0;
  O c=o_new(a->c+32);
  for(q1=a->c-1;q1>=0||c1!=0;q1--)
    {if(q1>=0)c1+=(long long)a->ss[q1]*(long long)b;
    c->ss[q1+32]=c1%obase;
    c1/=obase;}
  o_compress(c);
  return c;}

int o_print(O a)
  {int q1;
  for(q1=0;q1<a->c;q1++)printf("%c",a->ss[q1]<10?a->ss[q1]+48:a->ss[q1]+55);
  printf("\n");
  return 0;}

O convert(L aa,int b)
  {L a=l_copy2(aa);
  O o1=o_create(0),o2,o3,o4=o_create(1),o5;
  while(!l_iszero(a))
    {int c1=l_rem(a,b);
    o3=o_muln(o4,c1);
    o2=o_add(o3,o1);
    o_delete(o1);
    o_delete(o3);
    o1=o_copy(o2);
    o_delete(o2);
    l_doit(a,b,-1);
    o5=o_muln(o4,b);
    o_delete(o4);
    o4=o_copy(o5);
    o_delete(o5);}
  o_compress(o1);
  o_delete(o4);
  l_delete(a);
  return o1;}

int ohinit(void)
  {ohin=0;
  memset(oh,0,sizeof(oh));
  return 0;}
int output_hash(O a)
  {int c1=0,q1;
  for(q1=0;q1<a->c;q1++)c1=(c1*113+a->ss[q1])%maxoutput;
  return c1;}
int output_hash_put(O a,int pos)
  {int c1;
  c1=output_hash(a);
  while(oh[c1].a)c1=(c1+1)%maxoutput;
  oh[c1].a=o_copy(a);
  oh[c1].pos=pos;
  ohin++;
  return 0;}
int output_hash_find(O a)
  {int c1;
  c1=output_hash(a);
  while(oh[c1].a)
    {if(o_eq(a,oh[c1].a))return oh[c1].pos;
    c1=(c1+1)%maxoutput;}
  return -1;}
int ohrelease(void)
  {int q1;
  for(q1=0;q1<maxoutput;q1++)if(oh[q1].a)o_delete(oh[q1].a);
  memset(oh,0,sizeof(oh));
  return 0;}



char*o_divide(O aa,O bb,int*start,int*end,int*len)
  {ohinit();
  char*ans;
  int l=0,s=4;
  ans=(char*)mmalloc(sizeof(char)*s);
  memset(ans,0,sizeof(char)*s);
  
  *start=-1;
  *end=-1;
  int q1,q2,q3,c1,c2,c3,c4=0;
  
  O e1=o_create(0),e2,e3,e4,e5,e6;
  for(q1=0;;q1++)
    {
    if(bb->c*sizeof(char)*ohin>maxoutputhashsize)break;
    if(ohin>maxoutput/3)break;
    if(q1>=aa->c)
      {if((c4=output_hash_find(e1))!=-1)
        {*start=c4;
        *end=q1-1;
        break;}
      output_hash_put(e1,q1);
      e2=o_muln(e1,obase);
      o_delete(e1);
      e1=o_copy(e2);
      o_delete(e2);}
    else
      {e2=o_muln(e1,obase);
      o_delete(e1);
      e1=o_copy(e2);
      o_delete(e2);
      e3=o_create(aa->ss[q1]);
      e2=o_add(e1,e3);
      o_delete(e1);
      o_delete(e3);
      e1=o_copy(e2);
      o_delete(e2);}
    for(q2=0;q2<obase;q2++)
      {e2=o_muln(bb,q2);
      if(o_gr(e2,e1))
        {o_delete(e2);
        break;}
      o_delete(e2);}
    q2--;
    mem_char_put(&ans,&s,&l,q2);
    e2=o_muln(bb,q2);
    e3=o_sub(e1,e2);
    o_delete(e2);
    o_delete(e1);
    e1=o_copy(e3);
    o_delete(e3);}
  
  o_delete(e1);
  *len=l;
  ohrelease();
  return ans;}
