#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cmath>
#include<string>
#include<vector>
#include<sstream>
#include<iostream>
#include<algorithm>

using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define sz size()
#define cs c_str()
#define ALL(a) (a).begin(),(a).end()
/////////////////////////
#define eps 1e-10
#define inf 1e12

struct point
{
double x,y;
point (){x=y=0.0;};
point (double a,double b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

struct lineeq{double a,b,c;};

bool eq(double a,double b){if(a-b<eps&&b-a<eps)return 1;return 0;}
int get(double a)
  {if(eq(a,0.0))return 0;else if(a>0.0)return 1;else return -1;}

double operator!(const point&a){return hypot(a.x,a.y);}
point operator^(const point&a,const double&b){return point(cos(b)*a.x-sin(b)*a.y,sin(b)*a.x+cos(b)*a.y);}
point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
point operator*(const double&a,const point&b){return point(a*b.x,a*b.y);}
double operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
bool operator==(const point&a,const point&b){return eq(a.x,b.x)&&eq(a.y,b.y);}

bool operator||(const line&a,const line&b)
  {return eq((a.b-a.a)^(b.a-a.a),(a.b-a.a)^(b.b-a.a));}
bool operator>(const line&a,const line&b)
  {int s1=get((a.b-a.a)^(b.a-a.a));
  int s2=get((a.b-a.a)^(b.b-a.a));
  if(s1*s2<=0)return 1;
  else return 0;}


lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}

lineeq findeq(line&a)
  {return findeq2(a.a.x,a.a.y,a.b.x,a.b.y);}

point operator^(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point fc(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point operator*(const line&a,const line&b)
  {double t=((a.a-b.b)^(b.a-b.b))/((a.b-a.a)^(b.a-b.b));
  return a.a-t*(a.b-a.a);}

///////////////////////////////////////////////

double f(double x)
  {
  return x*x;
  }

double f1(double x)
  {
  return 2.0*x;
  }

double f2(double x)
  {
  return 2.0;
  }

double r2(double x)
  {
  int q1;
  double c1,c2,pi,c3,c4,c5,c6;
  point p1,p2,p3,p4,p5;
  line l1,l2,l3;
  
  pi=acos(-1.0);
  c1=1.0;
  
  for(q1=0;q1<10;q1++)
    {
    p1=point(x,f(x));
    p2=point(x+c1,f(x+c1));
    
    c3=f1(x);
    c4=f1(x+c1);
    
    c5=(c3-c4)/(sqrt(1.0+c3*c3)*sqrt(1.0+c4*c4));
    c5=abs(c5);
    
    c6=!(p1-p2);
    
    c2=c6/c5;
        
  //  printf("%.16lf     -     %.16lf\n",c1,c2);
    
    c1/=10.0;}
    
  return c2;}

double r(double x)
  {
  int q1;
  double c1,c2,pi;
  point p1,p2,p3,p4,p5;
  line l1,l2,l3;
  
  pi=acos(-1.0);
  c1=1.0;
  
  for(q1=0;q1<10;q1++)
    {
    p1=point(x,f(x));
    p2=point(x+c1,f(x+c1));
    
    p3=point(p1.x+1.0,p1.y+f1(x));
    p4=point(p2.x+1.0,p2.y+f1(x+c1));
    
    p3=p1+((p3-p1)^(pi/2.0));
    p4=p2+((p4-p2)^(pi/2.0));
    
    l1=line(p1,p3);
    l2=line(p2,p4);
    
    p5=l1*l2;
    
    c2=!(p5-(1.0/2.0)*(p1+p2));
    
   // printf("%.16lf     -     %.16lf\n",c1,c2);
    
    c1/=10.0;}
    
  return c2;}

double cube(double a)
  {return a*a*a;}

double r3(double x)
  {
  return abs(cube(sqrt(1.0+f1(x)*f1(x)))/f2(x));
  }

double doit(double x)
  {
  double c1,c2,c3;
  c1=r(x);
  c2=r2(x);
  c3=r3(x);
  
  printf("%lf\n%.10lf\n%.10lf\n%.10lf\n\n",x,c1,c2,c3);
  
  return (c1+c2)/2.0;
  }

int main()
  {
  double pi=acos(-1.0);
  double c1,c2;
  
  //doit(1.0);
  
  
  for(c1=pi-0.1;c1<=pi+110.1;c1+=10.2)
    {
   // printf("%.1lf %.10lf\n",c1,r(c1));
    doit(c1);
    } 
    
  return 0;}