(define (fact a)
  (if (= a 1)
      1
      (* a (fact (- a 1)))))
  
               
(define (A x y)
  (cond ((= y 0) 0)
        ((= x 0) (* 2 y))
        ((= y 1) 2)
        (else (A (- x 1)
                 (A x (- y 1))))))

(define (fib n)
  (cond ((<= n 1) n)
        (else (+ (fib (- n 1)) 
                 (fib (- n 2))))))
(define (fib2 n)
  (define (fibiter n a b to)
    (if (> n to)
        a
        (fibiter (+ n 1) b (+ a b) to)))
  (fibiter 1 0 1 n))

(define (ways change)
  (define (valueof n)
    (cond ((= n 1) 1)
          ((= n 2) 5)
          ((= n 3) 10)
          ((= n 4) 25)
          ((= n 5) 50)))
  (define (cc change w)
    (cond ((= change 0) 1)
          ((<= w 0) 0)
          ((< change 0) 0)
          (else (+ (cc change (- w 1))
                   (cc (- change (valueof w)) w)))))
  (cc change 5))

(define (e111 n)
  (if (< n 3 )
      n
      (+ (* 1 (e111 (- n 1)))
         (* 2 (e111 (- n 2)))
         (* 3 (e111 (- n 3))))))

(define (e111i n)
  (define (doit a b c n)
    (if (= n 0) 
        a
        (doit b c (+ c b b a a a) (- n 1))))
  (doit 0 1 2 n))

(define (comb n k)
  (cond ((or (< k 0) (> k n)) 0)
        ((= n 0) 1)
        (else (+ (comb (- n 1) k)
                 (comb (- n 1) (- k 1))))))

(define (cube x) (* x x x))

(define (sine x)
  (define (p x) (- (* 3 x) (* 4 (cube x))))
  (define (sin1 x)
    (if (< x 0.00000000000000001)
        x
        (p (sin1 (/ x 3.0)))))
  (sin1 x))

(define (pow1 b n)
  (if (= n 0)
      1
      (* b (pow1 b (- n 1)))))

(define (pow2 b n)
  (define (poww n res)
    (if (= n 0)
        res
        (poww (- n 1) (* res b))))
  (poww n 1))

(define (sqr x) (* x x))

(define (pow3 b n)
   (cond ((= n 0) 1)
         ((= (remainder n 2) 0) (sqr (pow3 b (/ n 2))))
         (else (* b (pow3 b (- n 1))))))

(define (pow4 b n)
  (define (poww b n res)
    (cond ((= n 0) res)
          ((= (remainder n 2) 0) (poww (sqr b) (/ n 2) res))
          (else (poww b (- n 1) (* b res)))))
  (poww b n 1))

(define (fmul a b)
  (define (fm a b c)
    (cond ((= a 0) c)
          ((= (remainder a 2) 0) (fm (/ a 2) (* b 2) c))
          (else (fm (- a 1) b (+ c b)))))
  (fm a b 0))

(define (ff n)
  (define (fff a b c d n)
    (cond ((= n 0 ) a)
          ((= (remainder n 2) 0) 
           (fff a b
                (+ (* c c) (* d d))
                (+ (* 2 c d) (* d d))
                (/ n 2)))
          (else
           (fff 
            (+ (* b d) (* a c))
            (+ (* a d) (* b c) (* b d))
            c d (- n 1)))))
  (fff 0 1 0 1 n))

(define (gcd a b)
  (cond ((= b 0) a)
        (else (gcd b (remainder a b)))))

(define (divides a b)
  (= (remainder b a) 0))

(define (smallest n)
  (define (iter k)
    (cond ((< n (sqr k)) n)
          ((divides k n) k)
          (else (iter (+ k 1)))))
  (iter 2))
          
(define (prime? n)
  (= n (smallest n)))


(define (expmod b n m)
  (cond ((= n 0) 1)
        ((= (remainder n 2) 0)
         (remainder (sqr (expmod b (/ n 2) m)) m))
        (else
         (remainder (* b (expmod b (- n 1) m)) m))))

(define (fermatest n)
  (define (try a)
    (= (expmod a n n) a))
  (try (random (- n 1))))

(define (fft n)
  (define (try a)
    (= (expmod a n n) a))
  (define (iter a)
    (cond ((>= a n) #t)
          ((try a) (iter (+ a 1)))
          (else #f)))
  (iter 1))

(define (test n)
  (define (prin a)
    (display a)
    (newline)
    a)
  (define (iter a)
    (cond ((> a n) 0)
          ((fft a) (iter (+ 1 (prin a))))
          (else (iter (+ a 1)))))
          
  (iter 2))
                   

(define (fasttest n times)
  (cond ((= 0 times) #t)
        ((fermatest n) (fasttest n (- times 1)))
        (else #f)))

