(define (gcd a b) (if (= b 0) a (gcd b (remainder a b))))
(define (abs a) (* a (sig a)))
(define (sig a) (cond ((= a 0) 0) ((< a 0) -1) (else 1)))
(define (square a) (* a a))
;(define (cons x y)(define (ans f)(cond ((= f 0) x)((= f 1) y)(else x)))ans)(define (car a)(a 0))(define (cdr a)(a 1))
(define (cons x y)(lambda (m) (m x y)))(define (car a)(a (lambda (x y) x)))(define (cdr a)(a (lambda (x y) y)))


(define (addr x y)
  (maker (+ (* (num x) (den y))
            (* (den x) (num y)))
         (* (den x) (den y))))

(define (subr x y)
  (maker (- (* (num x) (den y))
            (* (den x) (num y)))
         (* (den x) (den y))))

(define (mulr x y)
  (maker (* (num x) (num y))
         (* (den x) (den y))))

(define (divr x y)
  (maker (* (num x) (den y))
         (* (den x) (nom y))))

(define (norm x)
  (let ((a (gcd (abs (num x)) (abs (den x)))))
    (maker2 (* (abs (/ (num x) a)) (* (sig (num x)) (sig (den x))))
            (abs (/ (den x) a)))))

(define (equalr x y)
  (= (* (num x) (den y))
     (* (den x) (num y))))

(define (equalr2 x y)
  (let ((x1 (norm x))
        (y1 (norm y)))
    (and (= (nom x) (nom y))
         (= (den x) (den y)))))

(define (maker2 a b)
  (cons a b))

(define (maker a b)
  (norm (maker2 a b)))

(define (num x)
  (car x))

(define (den x)
  (cdr x))

(define (printr x)
  (display (num x))
  (display "/")
  (display (den x))
  (display "\n"))

(define (makep x y) (cons (+ x 0.0) (+ y 0.0)))
(define (xp p) (car p))
(define (yp p) (cdr p))
(define (addp a b) (makep (+ (xp a) (xp b)) (+ (yp a) (yp b))))
(define (subp a b) (makep (- (xp a) (xp b)) (- (yp a) (yp b))))
(define (mulp a b) (makep (* (xp a) b) (* (yp a) b)))
(define (divp a b) (mulp a (/ 1.0 b)))
(define (dist a b) (sqrt (+ (square (- (xp a) (xp b))) (square (- (yp a) (yp b))))))

(define (makel a b) (cons a b))
(define (start-segment l) (car l))
(define (end-segment l) (cdr l))
(define (length l) (dist (start-segment l) (end-segment l)))

(define (midpoint l)
  (divp (addp (start-segment l) (end-segment l)) 2.0))

(define (print-point p)
  (display "(")
  (display (xp p))
  (display " , ")
  (display (yp p))
  (display ")\n"))
  
(define (rect1 l1 l2)
  (cons l1 l2))

(define (rect2 p1 p2 p3 p4)
  (cons (cons p1 p2) (cons p3 p4)))
  
(define (sides2 rect)
  (cons (dist (car (car rect)) (cdr (car rect))) (dist (car (car rect)) (cdr (cdr rect)))))

(define (sides1 rect)
  (cons (length (car rect)) (length (cdr rect))))
  
(define (sides rect) (sides2 rect))
  
(define (area rect)
  (let ((a (sides rect)))
    (* (car a) (cdr a))))

;(define rec1 (rect1 (makel (makep 1 1) (makep 1 2)) (makel (makep 1 1) (makep 2 1))))
(define rec2 (rect2 (makep 1 1) (makep 1 2) (makep 2 2) (makep 2 1)))

(define (realmake a b) (cons a b))
(define (make-int a b) (norm (realmake a b)))
(define (lower a) (car a))
(define (upper a) (cdr a))

(define (add a b) (make-int (+ (lower a) (lower b)) (+ (upper a) (upper b))))
(define (sub a b) (make-int (- (lower a) (upper b)) (- (upper a) (lower b))))
(define (norm a) (realmake (min (lower a) (upper a)) (max (lower a) (upper a))))
(define (mul a b)
  (let ((c1 (* (lower a) (lower b)))
        (c2 (* (upper a) (lower b)))
        (c3 (* (lower a) (upper b)))
        (c4 (* (upper a) (upper b))))
    (make-int (min c1 c2 c3 c4) (max c1 c2 c3 c4))))

(define (length a) (- (upper a) (lower a)))
(define (neg a) (make-int (- 0 (upper a)) (- 0 (lower a))))
(define (rec a) (norm (make-int (/ 1 (lower a)) (/ 1 (upper a)))))
(define (div2 a b) (mul a (rec b)))
(define (contain a b) (and (>= b (lower a)) (<= b (upper a))))

(define (div a b)
  (if (contain b 0)
      "error"
      (div2 a b)))
   

(define (out a)
  (display "( ")
  (display (lower a))
  (display " , ")
  (display (upper a))
  (display " )\n"))

(define r1 (make-int 1 2))
(define r2 (make-int 4 8))

(define (mul2 l1 l2)
  (let ((a (lower l1))
        (b (upper l1))
        (c (lower l2))
        (d (upper l2)))
    (cond ((and (>= a 0) (>= c 0)) (make-int (* a c) (* b d)))
          ((and (>= a 0) (>= d 0)) (make-int (* a d) (* b d)))
          ((and (>= a 0) (<= d 0)) (make-int (* b c) (* a d)))
          ((and (>= b 0) (>= c 0)) (make-int (* a d) (* b d)))
          ((and (>= b 0) (>= d 0)) (make-int (min (* a d) (* b c)) (max (* a c) (* b d))))
          ((and (>= b 0) (<= d 0)) (make-int (* b c) (* a c)))
          ((and (<= b 0) (>= c 0)) (make-int (* a d) (* b c)))
          ((and (<= b 0) (>= d 0)) (make-int (* b c) (* a c)))
          ((and (<= b 0) (<= d 0)) (make-int (* b d) (* a c)))
          (else (cons 0 0)))))

(define (make-int-center c w)
  (make-int (- c w) (+ c w)))

(define (center a)
  (/ (+ (lower a) (upper a)) 2))

(define (width a)
  (/ (length a) 2))

(define (make-center-percent c p)
  (make-int (* (/ c p) 100) (/ (* c p) 100)))

(define (percent a)
  (* (/ (center a) (lower a)) 100))

