;(define (cons x y)(lambda (m) (m x y)))(define (car a)(a (lambda (x y) x)))(define (cdr a)(a (lambda (x y) y)))
(define (square a) (* a a))
(define (divides a b)
  (= (remainder b a) 0))
(define (smallest n)
  (define (iter k)
    (cond ((< n (square k)) n)
          ((divides k n) k)
          (else (iter (+ k 1)))))
  (iter 2))
(define (prime? n)
  (= n (smallest n)))

(define (list-ref lst n)
  (if (= n 0) (car lst)
      (list-ref (cdr lst) (- n 1))))

(define (length lst)
  (if (null? lst)
      0
      (+ 1 (length (cdr lst)))))

(define (length2 lst)
  (define (iter lst num)
    (if (null? lst)
        num
        (iter (cdr lst) (+ 1 num))))
  (iter lst 0))

(define (append l1 l2)
  (if (null? l1)
      l2
      (cons (car l1) (append (cdr l1) l2))))

(define (last-pair lst)
  (cond ((null? lst) '())
        ((null? (cdr lst)) lst)
        (else (last-pair (cdr lst)))))

(define (reverse lst)
  (if (null? lst)
      lst
      (append (reverse (cdr lst)) (cons (car lst) null))))

(define (reverse2 lst)
  (define (iter lst sofar)
    (if (null? lst)
        sofar
        (iter (cdr lst) (cons (car lst) sofar))))
  (iter lst '()))
      
(define (cc amount coins)
    (cond ((= amount 0) 1)
          ((or (< amount 0) (no-more? coins)) 0)
          (else (+ (cc amount (butfirst coins))
                   (cc (- amount (first coins))
                       coins)))))

(define (no-more? coins)
  (equal? coins '()))
(define (first coins)
  (car coins))
(define (butfirst coins)
  (cdr coins))

(define us-coins '(50 25 10 5 1))
(define uk-coins '(100 50 20 10 5 2 1 0.5))

(define (samepar . lst)
  (define (iter lst first)
    (if (equal? lst '())
        lst
        (append (if (= (remainder first 2) (remainder (car lst) 2)) 
                    (cons (car lst) null)
                    '())
                (iter (cdr lst) first))))
  (iter lst (car lst)))
 

(define (scale-list lst fac)
  (if (null? lst)
      lst
      (cons (* fac (car lst))
            (scale-list (cdr lst) fac))))

(define (map2 f l)
  (if (null? l)
      l
      (cons (f (car l))
            (map2 f (cdr l)))))

(define (scale-list2 lst fac)
  (map (lambda (x) (* x fac)) lst))
  
(define (square-list items)
  (if (null? items)
      null
      (cons ((lambda (x) (* x x)) (car items))
            (square-list (cdr items)))))

(define (square-list2 items)
  (map (lambda (x) (* x x)) items))

(define (for-each f l)
  (if (null? l) l
      (cons (f (car l))
            (for-each f (cdr l)))))

(define (acc lst fun zero)
  (if (null? lst)
      zero
      (fun (car lst)
           (acc (cdr lst) fun zero))))

(define (tree data chs)
  (cons data chs))
(define (data tree)
  (car tree))
(define (chs tree)
  (cdr tree))

(define (leaves tree)
  (if (null? (chs tree))
      1
      (acc (map size (chs tree))
           +
           0)))

(define (tree-leave? a)
  (null? (chs a)))

(define (size tree)
  (acc (map size (chs tree)) + 1))

(define (count-leaves a)
  (cond ((null? a) 0)
        ((not (pair? a)) 1)
        (else (+ (count-leaves (car a))
                 (count-leaves (cdr a))))))

(define (leave? a)
  (not (list? a)))

(define l3 (list 1 2 3))
(define l2 (list 4 5))
(define l1 (list 6))
(define l4 (list 7 8 9 0))
(define l5 (list l2 l4 l1 l3))
(define l6 (list l1 l3 l4))
(define l7 (list l2 l3 l4))
(define l8 (list l1 l2 l4))
(define l9 (list l5 l3 l7))
(define l10 (list l4 l6 l7 l1))
(define l11 (list l3 l1 l5 l9 l10))
(define l12 (list l11 l10 l9 l8 l7))
(define l13 (list l11 l12 l11 l10 l12 l10 l12 l11))
(define l14 (list l9 l8 l7 l10 l11 l12 l13 l12 l13 l11))
(define l15 (list l14 l13 l12 l11 l10 l10 l11 l12 l13 l14))

(define (reverseall lst)
  (define (iter lst sofar)
    (if (null? lst) 
        sofar
        (iter (cdr lst) (cons (if (list? (car lst)) 
                                  (reverseall (car lst))
                                  (car lst))
                              sofar))))
  (iter lst '()))

(define (listitlist tree)
  (if (leave? tree) 
      (list tree)
      (acc (map listitlist tree) append '())))

(define (listittree tree)
  (if (tree-leave? tree)
      tree
      (acc (map listittree (cdr tree)) append '())))

(define (make-mobile left right)
  (list left right))
(define (make-branch length struct)
  (list length struct))

(define (left-branch mobile)
  (car mobile))
(define (right-branch mobile)
  (car (cdr mobile)))
(define (branch-length branch)
  (car branch))
(define (branch-structure branch)
  (car (cdr branch)))

(define (weight-mob mobile)
  (if (not (list? mobile))
      mobile
      (+ (weight-mob (branch-structure (left-branch mobile)))
         (weight-mob (branch-structure (right-branch mobile))))))

(define (balanced? mobile)
  (define (balan mobile)
    (if (not (list? mobile))
        (cons #t mobile)
        (let ((l (balan (branch-structure (left-branch mobile))))
              (r (balan (branch-structure (right-branch mobile)))))
          (cons (and 
                 (car l) 
                 (car r) 
                 (= (* (cdr l) (branch-length (left-branch mobile))) 
                    (* (cdr r) (branch-length (right-branch mobile)))))
                (+ (cdr l) (cdr r))))))
  (car (balan mobile)))
                  
(define emptymob (list '() '()))
(define b1 (make-branch 5 8))
(define b2 (make-branch 7 5))
(define m1 (make-mobile b1 b2))

(define (scale-tree tree factor)
  (if (number? tree)
      (* tree factor)
      (map (lambda (x) (scale-tree x factor)) tree)))

(define (scaletree tree factor)
  (if (null? (chs tree))
      (list (* (data tree) factor))
      (cons (* factor (data tree))
            (map (lambda (x) (scaletree x factor)) (chs tree)))))

(define (squaretree tree)
  (cond ((number? tree) (* tree tree))
        ((null? tree) tree)
        (else (cons (squaretree (car tree))
                    (squaretree (cdr tree))))))

(define (treemap tree f)
  (cond ((not (list? tree)) (f tree))
        ((null? tree) tree)
        (else (cons (treemap (car tree) f)
                    (treemap (cdr tree) f)))))

(define (subsets set)
  (if (null? set) (list set)
      (let ((a (subsets (cdr set))))
        (append (map (lambda (x) (cons (car set) x)) a)
                a))))

(define (sum-odd-squares tree)
  (cond ((null? tree) 0)
        ((not (pair? tree))
         (if (odd? tree) (square tree) 0))
        (else (+ (sum-odd-squares (car tree))
                 (sum-odd-squares (cdr tree))))))

(define (fib n)
  (if (<= n 1) n
      (+ (fib (- n 1)) (fib (- n 2)))))

(define (even-fibs n)
  (define (next k)
    (if (> k n)
        '()
        (let ((f (fib k)))
          (if (even? f)
              (cons f (next (+ k 1)))
              (next (+ k 1))))))
  (next 0))

(define (filter predicate sequence)
  (cond ((null? sequence) sequence)
        ((predicate (car sequence)) 
         (cons (car sequence)
               (filter predicate (cdr sequence))))
        (else (filter predicate (cdr sequence)))))

(define (accumulate op initial sequence)
  (if (null? sequence)
      initial
      (op (car sequence)
          (accumulate op initial (cdr sequence)))))
         
(define (enum low high)
  (if (> low high)
      null
      (cons low (enum (+ low 1) high))))

(define (enumtree tree)
  (cond ((null? tree) null)
        ((not (pair? tree)) (list tree))
        (else (append (enumtree (car tree))
                      (enumtree (cdr tree))))))

(define (sum-odd-squares2 tree)
  (accumulate + 0 (map square (filter odd? (enumtree tree)))))

(define (even-fibs2 n)
  (accumulate cons null (filter even? (map fib (enum 0 n)))))
               
(define (list-fib-squares n)
  (map square (map fib (enum 0 n))))

(define (oddsquareproduct seq)
  (accumulate * 1 (map square (filter odd? seq))))

(define (map3 f l)
  (accumulate (lambda (x y) (cons (f x) y)) null l))

(define (append2 l1 l2)
  (accumulate cons l2 l1))

(define (length2 l)
  (accumulate (lambda (x y) (+ y 1)) 0 l))

(define (eval x coef)
  (accumulate (lambda (this higher) (+ this (* x higher))) 0 coef))

(define (count-leaves2 tree)
  (accumulate (lambda (x y) (+ y
                               (if (list? x)
                                   (count-leaves2 x)
                                   1)))
              0
              tree))

(define (count-leaves3 tree)
  (if (list? tree)
      (accumulate + 0 (map count-leaves3 tree))
      1))

(define (accn op init ls)
  (if (null? (car ls))
      null
      (cons (accumulate op init (map car ls))
            (accn op init (map cdr ls)))))

(define (map f . l)
  (if (null? (car l))
      null
      (cons (apply f (map2 car l))
            (apply map f (map2 cdr l)))))

(define lis (list (list 1 2 3) (list 4 5 6) (list 7 8 9)))

(define (dot a b)
  (accumulate + 0 (map * a b)))

(define (add a b)
  (if (null? a) null
      (cons (+ (car a) (car b)) (add (cdr a) (cdr b)))))

(define (scale a c)
  (if (null? a) null
      (cons (* (car a) c) (scale (cdr a) c))))

(define (sub a b)
  (add a (scale b -1)))

(define (mat*vec mat vec)
  (map (lambda (x) (dot x vec)) mat))

(define (transpose mat)
  (accn (lambda (x y) (cons x y)) null mat))

(define (mat*mat m1 m2)
  (let ((mm2 (transpose m2)))
    (map (lambda (y) (mat*vec mm2 y)) m1)))

(define (fold-left op initial seq)
  (define (iter result rest)
    (if (null? rest)
        result
        (iter (op result (car rest))
              (cdr rest))))
  (iter initial seq))

(define (rev3 l)
  (accumulate (lambda (x y) (append y (list x))) null l))
        
(define (rev4 l)
  (fold-left (lambda (x y) (cons y x)) null l))

(define (flatmap f l)
  (accumulate append null (map f l)))

(define (prime-sum? l)
  (prime? (+ (car l) (cadr l))))

(define (make_pair pair)
  (list (car pair) (cadr pair) (+ (car pair) (cadr pair))))

(define (prime-sum-pairs n)
  (map make_pair
       (filter prime-sum?
               (flatmap 
                (lambda (x) (map (lambda (y) (list y x))
                                 (enum 1 (- x 1))))
                (enum 1 n)))))

(define (remove item seq)
  (filter (lambda (x) (not (= x item))) seq))

(define (perms s)
  (if (null? s)
      (list null)
      (accumulate append null (map (lambda (x) (map (lambda (y) (cons x y)) (perms (remove x s)))) s))))
      
(define (unique n)
  (accumulate append null (map (lambda (x) (map (lambda (y) (list y x)) (enum 1 (- x 1)))) (enum 1 n))))

(define (primesum n)
  (map make_pair (filter prime-sum? (unique n))))

(define (pairs n)
  (accumulate append null 
              (map (lambda (x) 
                     (filter (lambda (z) (not (= (cadr z) x))) 
                             (map (lambda (y) (list x y)) 
                                  (enum 1 n)))) 
              (enum 1 n))))

(define (triples n s)
  (filter (lambda (x) (and (<= (caddr x) n) (>= (caddr x) 1) (not (= (caddr x) (car x))) (not (= (caddr x) (cadr x)))))
          (map (lambda (x) (append x (list (- s (car x) (cadr x)))))
               (pairs n))))

(define (trip n s)
    (filter (lambda (x) (and 
                         (<= (caddr x) n) 
                         (>= (caddr x) 1) 
                         (not (= (caddr x) (car x))) 
                         (not (= (caddr x) (cadr x)))
                         (> (cadr x) (car x))
                         (> (caddr x) (cadr x))
                         ))
          (map (lambda (x) (append x (list (- s (car x) (cadr x)))))
               (pairs n))))

(define (queen n)
  (define (queens k)
    (if (= k 0)
        (list null)
        (filter (lambda (x) (safe? x k))
                (flatmap (lambda (restof)
                           (map (lambda (new-row) (adjoin new-row k restof))
                                (enum 1 n)))
                         (queens (- k 1))))))
  (queens n))

(define (safe? l x)
  (define (calcbad l n)
    (if (null? (cdr l))
        '()
        (append (list (car l) (+ (- x n) (car l)) (- (car l) (- x n))) 
               (calcbad (cdr l) (+ n 1)))))
  (define (isnotmem l x)
    (cond ((null? l) #t)
          ((= (car l) x) #f)
          (else (isnotmem (cdr l) x))))
  (define (last l)
    (if (null? (cdr l))
        (car l)
        (last (cdr l))))
  (isnotmem (calcbad l 1) (last l)))

(define (adjoin new k rest)
  (if (null? rest)
      (list new)
      (cons (car rest) (adjoin new k (cdr rest)))))

(define a (list 16 -1.4 0))
(define b (list -8 8.1 4.2))
(define c (list 6.8 -7.2 0))

(dot a (add b c))
(dot b (add a c))
(dot c (add a b))