;these are almost all the exercises from chapter 3.5; at the end are included the homeweork and extra for experts problems
;(define null nil)
(define true #t)
(define false #f)
(define (memo f)
  (let ((res false) (ok false))
    (lambda ()
      (if ok res
          (begin
            (set! ok true)
            (set! res (f))
            res)))))

(define-syntax delay
  (syntax-rules ()
    ((delay z) (memo (lambda () z)))))
(define (force z) (z))

(define-syntax scons
    (syntax-rules ()
    ((scons a b) (cons a (delay b)))))
(define (sar a) (car a))
(define (sdr a) (force (cdr a)))

(define (prime? a)
  (define (iter b)
    (if (> (* b b) a) 
        true
        (if (= 0 (remainder a b)) 
            false
            (iter (+ b 1))))) 
  (if (< a 2) 
      #f
      (iter 2)))

(define (sref s n)
  (cond ((null? s) false)
        ((= n 0) (sar s))
        (else (sref (sdr s) (- n 1)))))
(define (smap2 f s)
  (if (null? s) null
      (scons (f (sar s)) (smap2 f (sdr s)))))
(define (sfilter f s)
  (cond ((null? s) null)
        ((f (sar s)) (scons (sar s) (sfilter f (sdr s))))
        (else (sfilter f (sdr s)))))
(define (sfor f s)
  (if (null? s) 'done
      (begin (f (sar s))
             (sfor f (sdr s)))))
(define (saccum f i s)
  (cond ((null? s) i)
        (else (f (sar s) (saccum f i (sdr s))))))
(define (show s)
  (sfor (lambda (x) (begin (display x) (display " "))) s)
  (newline))

(define (enum a b)
  (if (> a b) null
      (scons a (enum (+ a 1) b))))

(show (sfilter prime? (enum 1 100)))
(time (saccum + 0 (sfilter prime? (enum 1000000000 1000000050))))

(define (smap f . s)
  (if (null? (car s))
      null
      (scons (apply f (map sar s))
             (apply smap f (map sdr s)))))

(show (smap (lambda (x) (* x x)) (sfilter prime? (enum 1 100))))

(define (show1 x)
  (display x)
  (display " ")
  x)
  
(define x (smap show1 (enum 0 10))) (newline)
(sref x 5)
(sref x 7)

(define sum 0)
(define (accum x)
  (set! sum (+ x sum))
  sum)
(define seq (smap accum (enum 0 20)))
(define y (sfilter even? seq))
(define z (sfilter (lambda (x) (= (remainder x 5) 0)) seq))
(sref y 7)
(show z)
sum

(define (int a)
  (scons a (int (+ a 1))))
(define ints (int 0))
(define ints1 (int 1))

(define (/? x y) (= (remainder x y) 0))

(define (fib a b)
  (scons a (fib b (+ a b))))
(define fibs (fib 0 1))

(define (sieve a)
  (scons (sar a) (sieve (sfilter (lambda (x) (not (/? x (sar a)))) (sdr a)))))
(define primes (sieve (int 2)))
(sref primes 55)

(define (dsfor f s k)
  (if (or (= k 0) (null? s)) 'done
      (begin (f (sar s))
             (dsfor f (sdr s) (- k 1)))))
(define (dsaccum f i s k)
  (cond ((or (= k 0) (null? s)) i)
        (else (f (sar s) (dsaccum f i (sdr s) (- k 1))))))
(define (depshow s k)
  (dsfor (lambda (x) (begin (display x) (display " "))) s k)
  (display " ...")
  (newline))

(define (dshow s) (depshow s 19))

(dsaccum + 0 (sieve (int 2)) 500 )

(define ones (scons 1 ones))
(define (add s1 s2) (smap + s1 s2))

(define integers (scons 1 (add ones integers)))
(define fibs2 (scons 0 (scons 1 (add (sdr fibs2) fibs2))))
(dshow fibs2)
(define (scale s f) (smap (lambda (x) (* x f)) s))

(define double (scons 1 (scale double 2)))
(dshow double)

(define pr (scons 2 (sfilter prime2? (int 3))))
(define (prime2? a)
  (define (iter s)
    (if (> (* (sar s) (sar s)) a) 
        true
        (if (= 0 (remainder a (sar s)))
            false
            (iter (sdr s)))))
  (iter pr))
(depshow pr 29)
(dsaccum + 0 pr 500)

(define pow2 (scons 1 (add pow2 pow2)))
(depshow pow2 30)

(define (mul s1 s2) (smap * s1 s2))
(define facts (scons 1 (mul facts ints1)))
(depshow facts 30)

(define (partial s) 
  (scons (sar s) (smap (lambda (x) (+ x (sar s))) (partial (sdr s)))))
(dshow (partial ints))

(define (mer s1 s2)
  (cond ((null? s1) s2)
        ((null? s2) s1)
        (else 
         (let ((s11 (sar s1)) (s22 (sar s2)))
           (cond ((> s11 s22) (scons s22 (mer s1 (sdr s2))))
                 ((> s22 s11) (scons s11 (mer (sdr s1) s2)))
                 (else (scons s11 (mer (sdr s1) (sdr s2)))))))))

(define (merge . l)
  (cond ((null? l) null)
        ((null? (cdr l)) (car l))
        (else (mer (car l) (apply merge (cdr l))))))

(define S (scons 1 (merge (scale S 2) (scale S 3) (scale S 5))))
(depshow S 100)

(define (expand num den rad)
  (scons (quotient (* num rad) den)
         (expand (remainder (* num rad) den) den rad)))

(dshow (expand 1 7 10))
(dshow (expand 3 8 10))

;Expand shows the digits after the "decimal" of the fraction num/den in the given radix

(define (neg a) (smap (lambda (x) (- 0 x)) a))
(define (minus a b) (smap - a b))
(define zero (scons 0 zero))
(define (div a b) (smap / a b))
(define (integr a) (div a ints1))
(define expp (scons 1.0 (integr expp)))
(define sinn (scons 0.0 (integr coss)))
(define coss (scons 1.0 (neg (integr sinn))))
(depshow (partial expp) 13)
(define (power x) 
  (define res (scons 1 (scale res x)))
  res)

(define (cos1 x) (mul (power x) coss))
(define (sin1 x) (mul (power x) sinn))
(dshow (partial (cos1 2)))
(dshow (partial (sin1 1)))
(define (inter a) (scons 0 (scons (sar a) (inter (sdr a)))))
(define (inter1 a) (scons (sar a) (inter (sdr a))))
(define (muls a b) (scons (* (sar a) (sar b)) (smap + (muls (sdr a) (sdr b)) (scale (sdr a) (sar b)) (scale (sdr b) (sar a)))))
(define (muls1 a b) (scons (* (sar a) (sar b)) (add (muls1 (sdr a) b) (minus (muls1 a (sdr b)) (muls1 (sdr a) (sdr b))))))
(define (muls3 a b) (scons (* (sar a) (sar b)) (smap + (muls3 (sdr a) (sdr b)) (scale (sdr a) (sar b)) (scale (sdr b) (sar a)))))
(define (muls4 a b) (scons (* (sar a) (sar b)) (add (scale (sdr b) (sar a)) (muls4 (sdr a) b))))

(define exp2 (muls4 expp expp))
(depshow (partial exp2) 10)
(depshow exp2 10)

(define sin2 (muls4 sinn sinn))
(define cos2 (muls4 coss coss))
(define one (add sin2 cos2))
(depshow (partial one) 10)
(depshow one 10)

(define (rec a) (scons (sar a) (neg (muls (sdr a) (rec a)))))
(define tann (muls sinn (rec coss)))
(define (tan1 a) (mul (power a) tann))
(dshow (partial (tan1 1)))
(define (divs a b) (muls a (rec b)))

(define (avg a b) (/ (+ a b) 2))
(define (sqrtim g x)
  (avg g (/ x g)))

(define (sqrts x)
  (define g (scons 1.0 (smap (lambda (g) (sqrtim g x)) g)))
  g)
(depshow (sqrts 2) 10)

(define (pisum a) (scons (/ 1 a) (smap - (pisum (+ a 2)))))
(define pis (scale (partial (pisum 1)) 4.0))
(dshow pis)
(define (pi n) (avg (sref pis n) (sref pis (+ n 1))))
(pi 100)
(acos -1)

(define (square a) (* a a))
(define (euler s)
  (let ((s0 (sref s 0))(s1 (sref s 1))(s2 (sref s 2)))
    (scons (- s2 (/ (square (- s2 s1)) (+ s0 (* -2 s1) s2)))
           (euler (sdr s)))))

(define pifast (euler pis))
(define (pif n) (avg (sref pifast n) (sref pifast (+ n 1))))
(pif 100)

(define (tableaux trans s)
  (scons s (tableaux trans (trans s))))

(define (accl trans s)
  (smap sar (tableaux trans s)))

(define ufpi (accl euler pis))
;(dshow ufpi)
(sref ufpi 8)

(define (slimit s eps)
  (let ((a (sar s)) (b (sar (sdr s))))
     (if (< (abs (- a b)) eps) b
         (slimit (sdr s) eps))))

(slimit (sqrts 10) 0.00000001)

(define (lnsum a) (scons (/ 1 a) (neg (lnsum (+ a 1)))))
(define lns (partial (lnsum 1.0)))
(define flns (accl euler lns))
(sref flns 9)
(log 2)

(define (interleave a b)
  (if (null? a)
      b
      (scons (sar a) (interleave b (sdr a)))))

(define (pairs a b)
  (scons (list (sar a) (sar b))
         (interleave (smap (lambda (x) (list (sar a) x)) (sdr b))
                     (pairs (sdr a) (sdr b)))))

(define intpairs (pairs ints1 ints1))

(define pp (sfilter (lambda (a) (prime? (+ (car a) (cadr a)))) intpairs))

(dshow pp)

(define (append l a)
  (if (null? l) (list a)
      (cons (car l) (append (cdr l) a))))

(define (mix . l)
  (cond ((null? l) null)
        ((null? (car l)) (mix (cdr l)))
        (else (scons (sar (car l)) (apply mix (append (cdr l) (sdr (car l))))))))

(define (pairs1 a b)
  (scons (list (sar a) (sar b))
         (mix (mix (smap (lambda (x) (list (sar a) x)) (sdr b))
                   (smap (lambda (x) (list x (sar b))) (sdr a)))
              (pairs (sdr a) (sdr b)))))

(define (pairs2 a b)
  (scons (list (sar a) (sar b))
         (mix (smap (lambda (x) (list (sar a) x)) (sdr b))
              (smap (lambda (x) (list x (sar b))) (sdr a))
              (pairs (sdr a) (sdr b)))))

(define (pairs3 a b)
  (scons (list (sar a) (sar b))
         (mix (smap (lambda (x) (list (sar a) x)) (sdr b))
              (pairs (sdr a) (sdr b))
              (smap (lambda (x) (list x (sar b))) (sdr a)))))

(define (pairs4 a b)
  (scons (list (sar a) (sar b))
         (mix (smap (lambda (x) (list (sar a) x)) (sdr b))
              (pairs (sdr a) b))))

(dshow (pairs4 ints1 ints1))

(define (mer2 less a b)
  (if (less (sar a) (sar b))
      (scons (sar a) (mer2 less (sdr a) b))
      (scons (sar b) (mer2 less a (sdr b)))))

(define (merge2 less . l)
  (cond ((null? l) null)
        ((null? (cdr l)) (car l))
        (else (mer2 less (car l) (apply merge2 less (cdr l))))))


(define (less1 a b)
  (define (iter a b)
    (cond ((and (null? b) (null? a)) false)
          ((and (null? b) (not (null? a))) false)
          ((and (null? a) (not (null? b))) true)
          ((< (car a) (car b)) true)
          ((> (car a) (car b)) false)
          (else (iter (cdr a) (cdr b)))))
  (cond ((< (apply + a) (apply + b)) true)
        ((> (apply + a) (apply + b)) false)
        (else (iter a b))))
      
(define (pairs5 a b)
  (scons (list (sar a) (sar b))
         (merge2 less1  
                (smap (lambda (x) (list (sar a) x)) (sdr b))
                (pairs5 (sdr a) (sdr b)))))

(define intpairs1 (pairs5 ints1 ints1))
(dshow intpairs1)

(define pitagor (smap (lambda (x) (list (car x ) (cadr x) (sqrt (+ (square (car x)) (square (cadr x))))))
                 (sfilter (lambda (x) (integer? (sqrt (+ (square (car x)) (square (cadr x)))))) intpairs1)))

(depshow pitagor 10)

(define (less2 a b)
  (let ((a1 (car a)) (a2 (cadr a)) (b1 (car b)) (b2 (cadr b)))
    (< (+ (* a1 2) (* a2 3) (* a1 a2 5))
       (+ (* b1 2) (* b2 3) (* b1 b2 5)))))

(define (pairs6 a b)
  (scons (list (sar a) (sar b))
         (sfilter (lambda (x) (= (* (gcd (car x) 30) (gcd (cadr x) 30)) 1))
                  (merge2 less2
                          (smap (lambda (x) (list (sar a) x)) (sdr b))
                          (pairs6 (sdr a) (sdr b))))))
(define sol (pairs6 ints1 ints1))
(dshow sol)

(define (pairso f less a b)
  (scons (f (sar a) (sar b))
         (merge2 less
                  (smap (lambda (x) (f (sar a) x)) (sdr b))
                  (pairso f less (sdr a) (sdr b)))))

(define (makecube a b) (list a b (+ (cube a) (cube b))))
(define (cube a) (* a a a))
(define (cubeval a) (caddr a))
(define (cubefilter s)
  (if (not (= (cubeval (sar s)) (cubeval (sar (sdr s))))) (cubefilter (sdr s))
      (scons (cubeval (sar s)) (cubefilter (sdr s)))))
(define (cubeless a b)
  (< (caddr a) (caddr b)))
(define cubes (cubefilter (pairso makecube cubeless ints1 ints1)))
(depshow cubes 20)

(define (makesquare a b) (list a b (+ (* a a) (* b b))))
(define (squarefilter s)
  (if (or (not (= (cubeval (sar s)) (cubeval (sar (sdr s)))))
          (not (= (cubeval (sar s)) (cubeval (sar (sdr (sdr s)))))))
      (squarefilter (sdr s))
      (scons (list (sar s) (sar (sdr s)) (sar (sdr (sdr s))) (cubeval (sar s))) (squarefilter (sdr s)))))
(define sqs (squarefilter (pairso makesquare cubeless ints1 ints1)))
(depshow sqs 20)


(define (integ f c dt)
  (define int (scons c (add (scale f dt) int)))
  int)

(define (rc r c t)
  (lambda (i cap)
    (add (scale i r) (scale (iteg i (* cap c) t) (/ 1.0 c)))))

(define (ch s)
  (define (iter s p)
    (scons (if (< p 0) (if (< (sar s) 0) 0 1) (if (< (sar s) 0) -1 0))
           (iter (sdr s) (sar s))))
  (scons 0 (iter (sdr s) (sar s))))
(dshow (ch sinn))

(define (smooth s)
  (scons (avg (sar s) (sar (sdr s))) 
         (average (sdr s))))

(define (zeroch s)
  (ch (smooth s)))

;;;;;;;;;;;;;;;homework
;problem 2
(dshow (expand 1 7 10))

(define (facts l) (expand (car l) (cadr l) 10))
(define (approx s n)
  (if (= n 0) null
      (cons (sar s) (approx (sdr s) (- n 1)))))
(approx (facts '(1 7)) 4)
(approx (facts '(1 2)) 4)

;;extra for experts
;;exercises 59-62 done 
;proeblem 2

(define (sappend a b)
  (if (null? a) b
      (scons (sar a) (sappend (sdr a) b))))
(define (hanois n)
  (if (= n 0) null
      (sappend (hanois (- n 1))
               (scons n (hanois (- n 1))))))

;(dshow (hanois 5))
 
(define hanoi (scons 1 (interleave (add ones hanoi) ones)))   ;this is the solution
(depshow hanoi 55)
(depshow (hanois 55) 55)

;obviously it works
