;(turtles)
(cs)
(ht)
(define null '())
(define center (cons 200 200))
(define screen (cons 400 400))

(define (id x) x)

(define (flippairs p)
  (let ((p2 (beside p (fv p))))
    (below p2 p2)))

(define (rsplit p n)
  (if (= n 0)
      p
      (let ((s (rsplit p (- n 1))))
        (beside p (below s s)))))

(define (usplit p n)
  (if (= n 0)
      p
      (let ((s (usplit p (- n 1))))
        (below p (beside s s)))))

(define (urcsplit p n)
  (if (= n 0)
      p
      (let ((up (usplit p (- n 1)))
            (r (rsplit p (- n 1))))
        (let ((ul (beside up up))
              (br (below r r))
              (urc (urcsplit p (- n 1))))
          (beside (below p ul)
                  (below br urc))))))

(define (urcsplit2 p n)
  (if (= n 0)
      p
      (let ((up (usplit p (- n 1)))
            (r (rsplit p (- n 1))))
        (let ((ul (beside up nopaint))
              (br (below r nopaint))
              (urc (urcsplit2 p (- n 1))))
          (beside (below p ul)
                  (below br urc))))))

(define (square-limit1 p n)
  (let ((q (urcsplit p n)))
    (let ((half (beside (fh q) q)))
      (below (fv half) half))))

(define (square4 tl tr bl br)
  (lambda (p)
    (let ((top (beside (tl p) (tr p)))
          (bottom (beside (bl p) (br p))))
      (below bottom top))))

(define (flippairs3 p)
  (let ((comb (square4 id fv id fv)))
    (comb p)))

(define (square-limit p n)
  (let ((q (urcsplit p n)))
    (let ((half (beside (fh q) q)))
      (below (fv half) half))))

(define (vec x y)
  (cons x y))
(define (x v)
  (car v))
(define (y v)
  (cdr v))
(define zv (cons 0 0))
(define (my v)
  (vec (car v) (* -1 (cdr v))))
(define (mx v)
  (vec (* -1 (car v)) (cdr v)))

(define (frame v1 v2 v3)
  (list v1 v2 v3))
(define (orig f)
  (car f))
(define (xedge f)
  (cadr f))
(define (yedge f)
  (caddr f))

(define (frame2 v1 v2 v3)
  (cons v1 (cons v2 v3)))
(define (orig2 f)
  (car f))
(define (xedge2 f)
  (cadr f))
(define (yedge2 f)
  (cddr f))


(define (addv v1 v2)
  (cons (+ (x v1) (x v2)) (+ (y v1) (y v2))))
(define (scale c v1)
  (cons (* c (x v1)) (* c (y v1))))
(define (subv v1 v2)
  (addv v1 (scale -1 v2)))
(define (mid1 v1 v2)
  (scale (/ 1 2) (addv v1 v2)))

(define (segment x y)
  (cons x y))
(define (start s)
  (car s))
(define (end s)
  (cdr s))
(define (mid s)
  (mid1 (start s) (end s)))

(define unit (frame (vec 0 0) (vec 1 0) (vec 0 1)))

(define (fc f)
  (lambda (v)
    (addv
     (orig f)
     (addv (scale (x v)
                  (xedge f))
           (scale (y v)
                  (yedge f))))))

(define (paint l)
  (lambda (f)
    (for-each
     (lambda (s)
       (line
        ((fc f) (start s))
        ((fc f) (end s))))
    l)))

(define (segit p)
  (define (iter l)
    (if (= (length l) 1) null
        (cons (segment (car l) (cadr l))
              (iter (cdr l)))))
  (define (last l)
    (if (null? (cdr l)) (car l) (last (cdr l))))
  (cond ((null? p) null)
        ((null? (cdr p)) (list (segment (car p) (car p))))
        (else (append (iter p) (list (segment (last p) (car p)))))))

(define (frameoutline f)
  (list zv (xedge f) (addv (xedge f) (yedge f)) (yedge f)))
         

(define (outline1 frame)
  (paint (segit (frameoutline frame))))

(define (xf1 frame)
  (paint (list (segment zv (addv (yedge frame) (xedge frame)))
              (segment (xedge frame) (yedge frame)))))

(define (diamond1 frame)
  (paint (segit (map mid (segit (frameoutline frame))))))
   
(define outline (outline1 unit))
(define xf (xf1 unit))
(define diamond (diamond1 unit))

(define rawman (list
                (list 11 27 13 32)
                (list 21 27 19 32)
                (list 13 20 11 27)
                (list 19 20 21 27)
                (list 0 24 5 18)
                (list 0 19 5 12)
                (list 5 12 10 18)
                (list 5 18 10 20)
                (list 10 20 13 20)
                (list 12 15 10 18)
                (list 19 20 23 20)
                (list 23 20 32 13)
                (list 18 15 32 8)
                (list 8 0 12 15)
                (list 13 0 16 11)
                (list 19 0 16 11)
                (list 24 0 18 15)))

(define smile (list 
               (list 15 23 17 23)
               (list 15 23 13 25)
               (list 17 23 19 25)
               (list 13 25 16 24)
               (list 16 24 19 25)))

(define (trans p o x y)
  (lambda (f)
    (let ((m (fc f)))
      (let ((no (m o)))
        (p (frame no 
                  (subv (m x) no)
                  (subv (m y) no)))))))

(define (fv p)
  (trans p
         (vec 0 1)
         (vec 1 1)
         (vec 0 0)))

(define (fh p)
  (trans p
         (vec 1 0)
         (vec 0 0)
         (vec 1 1)))

(define (shrinktour p)
  (trans p
         (vec (/ 1 2) (/ 1 2))
         (vec 1 (/ 1 2))
         (vec (/ 1 2) 1)))

(define (rot90 p)
  (trans p
         (vec 1 0)
         (vec 1 1)
         (vec 0 0)))

(define (rot180 p) (rot90 (rot90 p)))
(define (rot270 p) (rot90 (rot90 (rot90 p))))

(define (squash p)
  (trans p
         (vec 0 0)
         (vec (/ 2 3) (/ 1 3))
         (vec (/ 1 3) (/ 2 3))))

(define (beside p1 p2)
  (let ((splitp (vec (/ 1 2) 0)))
    (let ((paintl (trans p1
                         (vec 0 0)
                         splitp
                         (vec 0 1)))
          (paintr (trans p2
                         splitp
                         (vec 1 0)
                         (vec (/ 1 2) 1))))
      (lambda (frame)
        (paintl frame)
        (paintr frame)))))

(define (below p1 p2)
  (let ((splitp (vec 0 (/ 1 2))))
    (let ((paintd (trans p1
                         (vec 0 0)
                         (vec 1 0)
                         splitp))
          (paintu (trans p2
                         splitp
                         (vec 1 (/ 1 2))
                         (vec 0 1))))
      (lambda (frame)
        (paintd frame)
        (paintu frame)))))

(define (below2 p1 p2)
  (rot90 (beside (rot270 p1) (rot270 p2))))

(define (split sm ss)
  (lambda (p n)
    (if (= n 0)
        p
        (let ((p1 ((split sm ss) p (- n 1))))
          (sm p (ss p1 p1))))))

(define (line1 segment)
  (pu)
  (setxy (x (start segment)) (y (start segment)))
  (pd)
  (setxy (x (end segment)) (y (end segment)))
  (pu)
  (setxy 0 0))

(define (move vec)
  (move-offset (x vec) (y vec)))
(define (ink vec)
  (draw-offset (x vec) (y vec)))

;(define (line1 seg)
;  (move (start seg))
;  (ink (subv (end seg) (start seg)))
;  (move (subv zv (end seg))))

(define (line v1 v2)
  (line1 (segment (subv v1 cent) (subv v2 cent))))

(define (lin seg)
  (line (start seg) (end seg)))

(define l1 (segment (vec 100 100) (vec 200 300)))
(define l2 (segment (vec 200 200) (vec 400 300)))
(define f1 (frame (vec 0 0) (vec (car screen) 0) (vec 0 (cdr screen))))
(define f2 (frame (vec 0 0) (vec 400 200) (vec 200 400)))
(define cent (vec (car center) (cdr center)))

(define man (map (lambda (x) (segment (vec (/ (car x) 32) (/ (cadr x) 32)) (vec (/ (caddr x) 32) (/ (cadddr x) 32)))) rawman))
(define smiley (map (lambda (x) (segment (vec (/ (car x) 32) (/ (cadr x) 32)) (vec (/ (caddr x) 32) (/ (cadddr x) 32)))) smile))

(define man (append man smiley))  ;;comment this for not smiling man.
  
(define nopaint (paint '()))
(define wave (paint man))

(define rsplit2 (split beside below))
(define usplit2 (split below beside))
(define wave2 (beside wave (fv wave)))
(define wave3 (below wave2 wave2))
(define wave4 (flippairs wave))
(define flippairs2 (square4 id fv id fv))

;;interface procedure names

(define flipped-pairs flippairs)          ;painter-manipulator
(define right-split rsplit)               ;painter-manipulator
(define corner-split urcsplit)            ;painter-manipulator
(define corner-split-252 urcsplit2)       ;painter-manipulator
(define square-limit square-limit)        ;painter-manipulator
(define up-split usplit)                  ;painter-manipulator
(define square-of-four square4)           ;painter-manipulator
(define identity id)                      ;painter-manipulator
(define frame-coord-map fc)               ;frame
(define make-frame frame)                 ;frame
(define segments->painter paint)          ;main-painter
(define start-segment start)              ;segment
(define end-segment end)                  ;segment
(define draw-outline outline)             ;painter
(define diamond diamond)                  ;painter
(define draw-X xf)                        ;painter
(define wave wave)                        ;painter
(define transform-painter trans)          ;painter-transformer
(define flip-vert fv)                     ;painter-transformer
(define flip-horiz fh)                    ;painter-transformer
(define shrink-to-upper-right shrinktour) ;painter-transformer
(define rotate90 rot90)                   ;painter-transformer
(define rotate180 rot180)                 ;painter-transformer
(define rotate270 rot270)                 ;painter-transformer
(define squash-inwards squash)            ;painter-transformer
(define beside beside)                    ;painter-combiner
(define below below)                      ;painter-combiner
(define full-frame f1)                    ;frame
