#include<stdio.h>
#include<math.h>
#include<stdlib.h>
#include<sstream>
#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
using namespace std;

#define VI vector < int >
#define VS vector < string >
#define pb push_back
#define cs c_str()
#define sz size()
#define ALL(a) (a).begin(),(a).end()
///////////////////////////////////////////
#define eps 1e-8
#define inf 1e12
#define M_PI acos(-1.0)

struct point
{
double x,y;
point (){x=y=0.0;};
point (double a,double b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

struct lineeq{double a,b,c;};

bool eq(double a,double b){if(a-b<eps&&b-a<eps)return 1;return 0;}
int get(double a)
  {if(eq(a,0.0))return 0;else if(a>0.0)return 1;else return -1;}


point operator^(const point&a,const double&b){return point(cos(b)*a.x-sin(b)*a.y,sin(b)*a.x+cos(b)*a.y);}
point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
point operator*(const double&a,const point&b){return point(a*b.x,a*b.y);}
point operator*(const point&b,const double&a){return point(a*b.x,a*b.y);}
point operator/(const point&b,const double&a){return point(b.x/a,b.y/a);}
double operator!(const point&a){return hypot(a.x,a.y);}
double operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
double operator~(const point&a){return atan2(a.y,a.x);}
bool operator==(const point&a,const point&b){return eq(a.x,b.x)&&eq(a.y,b.y);}
bool operator!=(const point&a,const point&b){return !(a==b);}
bool operator<(const point&a,const point&b){return a.x<b.x||( eq(a.x,b.x) && a.y<b.y );}

bool operator||(const line&a,const line&b)
  {return eq((a.b-a.a)^(b.a-a.a),(a.b-a.a)^(b.b-a.a));}
bool operator>(const line&a,const line&b)
  {int s1=get((a.b-a.a)^(b.a-a.a));
  int s2=get((a.b-a.a)^(b.b-a.a));
  if(s1*s2<=0)return 1;
  else return 0;}


lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}

lineeq findeq(line&a)
  {return findeq2(a.a.x,a.a.y,a.b.x,a.b.y);}

point operator^(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point operator*(const line&a,const line&b)
  {double t=((a.a-b.b)^(b.a-b.b))/((a.b-a.a)^(b.a-b.b));
  return a.a-t*(a.b-a.a);}

vector < line > four;

vector < pair < double, double > >  inter;

int nozero=0;

int get(point p1,point p2)
  {point p3=(p1+p2)/2.0,p4,p5;
  double d1,d2,d3;
  line l1,l2;
  vector < point > all;
  int q1,q2,c1,c2;
  
  p4=p3-p1;
  p4=p4^(acos(0.0));
  p4=p4+p3;
  l1=line(p3,p4);
  
  for(q1=0;q1<four.sz;q1++)if(l1>four[q1])
    all.pb(l1*four[q1]);
  
  sort(ALL(all));
  
  for(q1=c1=1;q1<all.sz;q1++)if(all[q1]!=all[c1-1])all[c1++]=all[q1];
  all.resize(c1);
  
  for(q1=0;q1<all.sz;q1++)all[q1]=all[q1]-p1;
  
  d1=atan2(all[0].x,all[0].y);
  d2=atan2(all[1].x,all[1].y);
    
  if(d1>d2){d3=d2;d2=d1;d1=d3;}  
  
  if(d2-d1>M_PI)
    {inter.pb(make_pair(-M_PI,d1));
    inter.pb(make_pair(d2,M_PI));
    nozero=1;}
  else
    inter.pb(make_pair(d1,d2));
  return 0;}
  
double best=1e100;

int test1(double a,point p1)
  {if(eq(a,M_PI)||eq(a,-M_PI))if(nozero)return 0;
  int q1,q2;
  point p2,p3;
  line l1;
  for(q1=0;q1<inter.sz;q1++)
    if(a>inter[q1].first&&a<inter[q1].second)if(!eq(a,inter[q1].first))if(!eq(a,inter[q1].second))break;
  if(q1!=inter.sz)return 0;

  l1=line(p1,point(p1.x+sin(a)*1000000.0,p1.y+cos(a)*1000000.0));
  for(q1=0;q1<four.sz;q1++)if(l1>four[q1])if(four[q1]>l1)
    {point p3=l1^four[q1];
    double c1=!(p1-p3);
    if(c1<best)
      best=c1;}  
    
  return 0;}

  
class CirclesOfDestruction
{public: 
double exitTime(int xSize, int ySize, int px, int py, vector <int> x, vector <int> y) 
  {int q1;
   
  if(px==0||py==0||px==xSize||py==ySize)return 0.0;
  
  four.pb(line(point(0.0,0.0),point((double)xSize,0.0)));
  four.pb(line(point(0.0,0.0),point(0.0,(double)ySize)));
  four.pb(line(point((double)xSize,0.0),point((double)xSize,(double)ySize)));
  four.pb(line(point(0.0,(double)ySize),point((double)xSize,(double)ySize)));
  
  for(q1=0;q1<x.sz;q1++)if(px!=x[q1]||py!=y[q1])
    get(point((double)px,(double)py),point((double)x[q1],(double)y[q1]));
  
  for(q1=0;q1<inter.sz;q1++)
    {test1(inter[q1].first,point((double)px,(double)py));
    test1(inter[q1].second,point((double)px,(double)py));}
  
  test1(0.0,point((double)px,(double)py));  
  test1(M_PI/2.0,point((double)px,(double)py));  
  test1(M_PI,point((double)px,(double)py));  
  test1(-M_PI/2.0,point((double)px,(double)py));  
  
  if(best>1000000.0)  best=-1.0;
  return best;} 