/*
PROG: alpine
LANG: C++
*/

#ifndef __GNUC__
#define bool int
#endif
#include<stdio.h>
#include<time.h>
#include<stdlib.h>
#include<math.h>
#define mx 32768
#define in fopen("alpine.in","r")
#define out fopen("alpine.out","w")
FILE*fn;
#define eps 1e-8
#define inf 1e12
#define end 1e6

struct point
{
double x,y;
point (){x=y=0.0;};
point (double a,double b){x=a;y=b;};
};

struct line
{
point a,b;
line (){};
line (point p1,point p2){a=p1;b=p2;};
};

struct lineeq{double a,b,c;};

bool eq(double a,double b){if(a-b<eps&&b-a<eps)return 1;return 0;}
int get(double a)
  {if(eq(a,0.0))return 0;else if(a>0.0)return 1;else return -1;}

point operator+(const point&a,const point&b){return point(a.x+b.x,a.y+b.y);}
point operator-(const point&a,const point&b){return point(a.x-b.x,a.y-b.y);}
point operator*(double&a,const point&b){return point(a*b.x,a*b.y);}
double operator^(const point&a,const point&b){return a.x*b.y-a.y*b.x;}
bool operator==(const point&a,const point&b){return eq(a.x,b.x)&&eq(a.y,b.y);}

bool operator||(const line&a,const line&b)
  {return eq((a.b-a.a)^(b.a-a.a),(a.b-a.a)^(b.b-a.a));}
bool operator>(const line&a,const line&b)
  {int s1=get((a.b-a.a)^(b.a-a.a));
  int s2=get((a.b-a.a)^(b.b-a.a));
  if(s1*s2<=0)return 1;
  else return 0;}


lineeq findeq2(double x1,double y1,double x2,double y2)
  {lineeq e1;
  e1.a=y2-y1;
  e1.b=x1-x2;
  e1.c=y1*x2-y2*x1;
  return e1;}

lineeq findeq(line&a)
  {return findeq2(a.a.x,a.a.y,a.b.x,a.b.y);}

point operator^(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point fc(line&a,line&b)
  {lineeq p1,p2;
  point e1;
  p2=findeq(a);
  p1=findeq(b);
  e1.y=(p2.a*p1.c-p2.c*p1.a)/(p2.b*p1.a-p2.a*p1.b);
  e1.x=(p1.b*p2.c-p2.b*p1.c)/(p2.b*p1.a-p2.a*p1.b);
  return e1;}

point operator*(const line&a,const line&b)
  {double t=((a.a-b.b)^(b.a-b.b))/((a.b-a.a)^(b.a-b.b));
  return a.a-t*(a.b-a.a);}

///////////////////////////////////////////////
line ply[mx];
int lc;

int cut(line a)
  {line ccut;
  int q1,c1=-1,c2=-1;

  for(q1=0;q1<lc;q1++)
    if(a>ply[q1])
      {point p1=a*ply[q1];
      if(c1==-1)ccut.a=p1;
      else ccut.b=p1;
      if(c1==-1)c1=q1;
      else c2=q1;
      if(p1==ply[q1].b)q1++;
      continue;}

  if(c1>=0&&c2>=0)
    {
    ply[c1].b=ccut.a;
    if(c1+1==c2)for(q1=lc;q1>c1+1;q1--)ply[q1]=ply[q1-1];
    else for(q1=c1+2;q1<lc-(c2-c1-2);q1++)ply[q1]=ply[q1+c2-c1-2];
    ply[c1+1]=ccut;
    ply[c1+2].a=ccut.b;
    lc-=(c2-c1-2);}

  return 0;}

point ss[mx];

int q1,c;

double b1=inf,b2;
int main()
  {fn=in;
  fscanf(fn,"%d",&c);
  for(q1=0;q1<c;q1++)
    {double c1,c2;
    fscanf(fn,"%lf %lf",&c1,&c2);
    ss[q1]=point(c1,c2);}
  fclose(fn);
  ply[lc++]=line(point(-end,inf),point(-end,-end));
  ply[lc++]=line(point(-end,-end),point(end,-end));
  ply[lc++]=line(point(end,-end),point(end,inf));

  for(q1=0;q1<c-1;q1++)
    {
    line l1(ss[q1],ss[q1+1]);

    cut(l1);
    }

  int c1=0,c2=0;
  for(q1=0;q1<c;q1++)
    {
    while(ply[c1].b.x<ss[q1].x)c1++;

    point p1=line(ss[q1],point(ss[q1].x,inf))*ply[c1];

    double c3=p1.y-ss[q1].y;
    if(c3<b1&&(!eq(c3,b1)))
      {b1=c3;
      b2=ss[q1].x;}
    }

  point p1=line(ss[0],ss[1])*line(ss[4],ss[5]);

  for(q1=1;q1<lc-2;q1++)
    {
    if(ply[q1].b.x<ss[0].x||ply[q1].b.x>ss[c-1].x)continue;

    while(ply[q1].b.x>ss[c2].x)c2++;

    line l1;
    point p1=(l1=line(ply[q1].b,point(ply[q1].b.x,-end)))*line(ss[c2],ss[c2-1]);

    double c3=ply[q1].b.y-p1.y;

    if(((!eq(c3,b1))&&c3<b1)||(eq(c3,b1)&&ply[q1].b.x<b2))
      {b1=c3;
      b2=ply[q1].b.x;}
    }
  if(eq(b1,0.0))b1=0.0;
  fn=out;
  fprintf(fn,"%.2lf\n%.2lf\n",b1,b2);
  fclose(fn);
  return 0;}